************************************************************************    
*
*       common.inc
*
*       Definition of geant and user common blocks
*
*       History
*       -------
*       15AUG95 SR created
*       04OCT95 EF added event generator common blocks
*
************************************************************************    
*
*-----------------------------------------------------------------------
*
      EXTERNAL RANLUX

      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
*
      INTEGER       JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
*
*-----------------------------------------------------------------------
*
      COMMON/GCTMED/NUMED,NATMED(5),ISVOL,IFIELD,FIELDM,TMAXFD,STEMAX
     +      ,DEEMAX,EPSIL,STMIN,CFIELD,PREC,IUPD,ISTPAR,NUMOLD
*
      INTEGER       NUMED,NATMED,ISVOL,IFIELD,IUPD,ISTPAR,NUMOLD
      REAL          FIELDM,TMAXFD,STEMAX,DEEMAX,EPSIL,STMIN,CFIELD,PREC
*
*-----------------------------------------------------------------------
*
      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT
     +       ,IEORUN,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)

*
      INTEGER  	IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT,IFINIT,NEVENT,NRNDM
*
*-----------------------------------------------------------------------
*
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),XAMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
*
      INTEGER       IKINE,ITRA,ISTAK,IVERT,IPART,ITRTYP,NAPART,IPAOLD
      REAL          PKINE,XAMASS,CHARGE,TLIFE,VERT,PVERT
*
*-----------------------------------------------------------------------
*
      INTEGER MAXMEC
      PARAMETER (MAXMEC=30)
      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(MAXMEC)
     + ,NAMEC(MAXMEC),NSTEP ,MAXNST,DESTEP,DESTEL,SAFETY,SLENG
     + ,STEP  ,SNEXT ,SFIELD,TOFG  ,GEKRAT,UPWGHT,IGNEXT,INWVOL
     + ,ISTOP ,IGAUTO,IEKBIN, ILOSL, IMULL,INGOTO,NLDOWN,NLEVIN
     + ,NLVSAV,ISTORY
*
      INTEGER NMEC,LMEC,NAMEC,NSTEP ,MAXNST,IGNEXT,INWVOL,ISTOP
     + ,IGAUTO,IEKBIN,ILOSL, IMULL,INGOTO,NLDOWN,NLEVIN,NLVSAV,ISTORY
     + ,MAXME1,NAMEC1
      REAL  VECT,GETOT,GEKIN,VOUT,DESTEP,DESTEL,SAFETY,SLENG ,STEP
     + ,SNEXT,SFIELD,TOFG  ,GEKRAT,UPWGHT
*
*-----------------------------------------------------------------------
*
      INTEGER MXGKIN
      PARAMETER (MXGKIN=1000)
      COMMON/GCKING/KCASE,NGKINE,GKIN(5,MXGKIN),
     +                           TOFD(MXGKIN),IFLGK(MXGKIN)
*
      INTEGER       KCASE,NGKINE ,IFLGK,MXPHOT,NGPHOT
      REAL          GKIN,TOFD,XPHOT

      PARAMETER (MXPHOT=1000)
      COMMON/GCKIN2/NGPHOT,XPHOT(11,MXPHOT)

      COMMON/GCKIN3/GPOS(3,MXGKIN)
      REAL GPOS
*
*-----------------------------------------------------------------------
*
      COMMON/GCNUM/NMATE ,NVOLUM,NROTM,NTMED,NTMULT,NTRACK,NPART
     +            ,NSTMAX,NVERTX,NHEAD,NBIT
*
      INTEGER      NMATE ,NVOLUM,NROTM,NTMED,NTMULT,NTRACK,NPART
     +            ,NSTMAX,NVERTX,NHEAD,NBIT
*
*-----------------------------------------------------------------------
*
      COMMON/GCVOLU/NLEVEL,NAMES(15),NUMBER(15),
     +LVOLUM(15),LINDEX(15),INFROM,NLEVMX,NLDEV(15),LINMX(15),
     +GTRAN(3,15),GRMAT(10,15),GONLY(15),GLX(3)
*
      INTEGER NLEVEL,NAMES,NUMBER,LVOLUM,LINDEX,INFROM,NLEVMX,
     +        NLDEV,LINMX
      REAL GTRAN,GRMAT,GONLY,GLX
*
*-----------------------------------------------------------------------
*
      COMMON/GCDRAW/NUMNOD,MAXNOD,NUMND1,LEVVER,LEVHOR,MAXV,IPICK,
     + MLEVV,MLEVH,NWCUT,JNAM,JMOT,JXON,JBRO,JDUP,JSCA,JDVM,JPSM,
     + JNAM1,JMOT1,JXON1,JBRO1,JDUP1,JSCA1,JULEV,JVLEV,
     + LOOKTB(16),
     + GRMAT0(10),GTRAN0(3),IDRNUM,GSIN(41),GCOS(41),SINPSI,COSPSI,
     + GTHETA,GPHI,GPSI,GU0,GV0,GSCU,GSCV,NGVIEW,
     + ICUTFL,ICUT,CTHETA,CPHI,DCUT,NSURF,ISURF,
     + GZUA,GZVA,GZUB,GZVB,GZUC,GZVC,PLTRNX,PLTRNY,
     + LINATT,LINATP,ITXATT,ITHRZ,IPRJ,DPERS,ITR3D,IPKHIT,IOBJ,LINBUF,
     + MAXGU,MORGU,MAXGS,MORGS,MAXTU,MORTU,MAXTS,MORTS,
     + IGU,IGS,ITU,ITS,NKVIEW,IDVIEW,
     + NOPEN,IGMR,IPIONS,ITRKOP,IHIDEN,
     + ZZFU,ZZFV,MYISEL,
     + DDUMMY(15)
C
      INTEGER NUMNOD,MAXNOD,NUMND1,LEVVER,LEVHOR,MAXV,IPICK,
     + MLEVV,MLEVH,NWCUT,JNAM,JMOT,JXON,JBRO,JDUP,JSCA,JDVM,JPSM,
     + JNAM1,JMOT1,JXON1,JBRO1,JDUP1,JSCA1,JULEV,JVLEV,
     + LOOKTB,IDRNUM,NGVIEW,ICUTFL,ICUT,NSURF,ISURF,LINATT,LINATP,
     + ITXATT,ITHRZ,IPRJ,ITR3D,IPKHIT,IOBJ,LINBUF,
     + MAXGU,MORGU,MAXGS,MORGS,MAXTU,MORTU,MAXTS,MORTS,
     + IGU,IGS,ITU,ITS,NKVIEW,IDVIEW,
     + NOPEN,IGMR,IPIONS,ITRKOP,IHIDEN
      REAL GRMAT0,GTRAN0,GSIN,GCOS,SINPSI,COSPSI,GTHETA,GPHI,GPSI,
     + GU0,GV0,GSCU,GSCV,CTHETA,CPHI,DCUT,GZUA,GZVA,GZUB,GZVB,GZUC,
     + GZVC,PLTRNX,PLTRNY,DPERS,DDUMMY,ZZFU,ZZFV,MYISEL
*
*-----------------------------------------------------------------------
*
      INTEGER  NJTMAX,NJTMIN,NTSTKP,NTSTKS,NDBOOK,NDPUSH,NJFREE,NJGARB,
     +         NJINVO,LINSAV,LMXSAV,NWSTAK,NWINT,NWREAL,NWTRAC
      INTEGER ISTORD
      PARAMETER (NWSTAK=12,NWINT=11,NWREAL=12,NWTRAC=NWINT+NWREAL+5)
      COMMON /GCSTAK/ NJTMAX, NJTMIN, NTSTKP, NTSTKS, NDBOOK, NDPUSH,
     +                NJFREE, NJGARB, NJINVO, LINSAV(15), LMXSAV(15)
      EQUIVALENCE (ISTORD,NJTMIN)
*
*-----------------------------------------------------------------------
*
      COMMON/GCSETS/IHSET,IHDET,ISET,IDET,IDTYPE,NVNAME,NUMBV(20)
      INTEGER       IHSET,IHDET,ISET,IDET,IDTYPE,NVNAME,NUMBV
*
*-----------------------------------------------------------------------
*      
      COMMON/GCPHYS/IPAIR,SPAIR,SLPAIR,ZINTPA,STEPPA,
     +              ICOMP,SCOMP,SLCOMP,ZINTCO,STEPCO,
     +              IPHOT,SPHOT,SLPHOT,ZINTPH,STEPPH,
     +              IPFIS,SPFIS,SLPFIS,ZINTPF,STEPPF,
     +              IDRAY,SDRAY,SLDRAY,ZINTDR,STEPDR,
     +              IANNI,SANNI,SLANNI,ZINTAN,STEPAN,
     +              IBREM,SBREM,SLBREM,ZINTBR,STEPBR,
     +              IHADR,SHADR,SLHADR,ZINTHA,STEPHA,
     +              IMUNU,SMUNU,SLMUNU,ZINTMU,STEPMU,
     +              IDCAY,SDCAY,SLIFE ,SUMLIF,DPHYS1,
     +              ILOSS,SLOSS,SOLOSS,STLOSS,DPHYS2,
     +              IMULS,SMULS,SOMULS,STMULS,DPHYS3,
     +              IRAYL,SRAYL,SLRAYL,ZINTRA,STEPRA
      INTEGER       IPAIR,ICOMP,IPHOT,IPFIS,IDRAY,IANNI,IBREM,
     +              IHADR,IMUNU,IDCAY,ILOSS,IMULS,IRAYL
      REAL          SPAIR,SLPAIR,ZINTPA,STEPPA,
     +              SCOMP,SLCOMP,ZINTCO,STEPCO,
     +              SPHOT,SLPHOT,ZINTPH,STEPPH,
     +              SPFIS,SLPFIS,ZINTPF,STEPPF,
     +              SDRAY,SLDRAY,ZINTDR,STEPDR,
     +              SANNI,SLANNI,ZINTAN,STEPAN,
     +              SBREM,SLBREM,ZINTBR,STEPBR,
     +              SHADR,SLHADR,ZINTHA,STEPHA,
     +              SMUNU,SLMUNU,ZINTMU,STEPMU,
     +              SDCAY,SLIFE ,SUMLIF,DPHYS1,
     +              SLOSS,SOLOSS,STLOSS,DPHYS2,
     +              SMULS,SOMULS,STMULS,DPHYS3,
     +              SRAYL,SLRAYL,ZINTRA,STEPRA
*
*-----------------------------------------------------------------------
*      
	COMMON/GCPARM/IPARM,PCUTGA,PCUTEL,PCUTNE,PCUTHA,PCUTMU,
     +                NSPARA,MPSTAK,NPGENE
	INTEGER       IPARM,NSPARA,MPSTAK,NPGENE
	REAL          PCUTGA,PCUTEL,PCUTNE,PCUTHA,PCUTMU
*
***********************************************************************
*
*       GPARAM stores systemwide user parameters
*
***********************************************************************
*
*  INTER:     0 for batch mode, 1 for interactive mode
*
*  VERSION:   Program version
*
*  ISEQ:      Randum number sequence, used to produce statistically in-
*             dependent data on different computers
*
*  ISEED:     Random number seeds, passed to GRNDMQ for event regeneration
*
*  IFILE:     0 for no putput, 1 for RZ file output
*
*  IFORMAT:   Output file format
* 
*  IGxxx:     Geometry flags for various parts of the detector,
*             0 for off, 1 for on
*
*  Wxxx:      Event generator weight: Branching ratio and Prescaling factor
*
*  IPLANAR:   If equal 1, event generators only produce events
*             in Y-Z plane, good for producing nice pictures
*
*  IWEIGHT:   Flag to choose different weighting method
*
*  ALPHA:     power when using power weighting method
*
*  A0:        used with logarithmic weighting
*----------------------------------------------------------------------
*
      COMMON/GPARAM/INTER,VERSION,ISEQ,ISEED1,ISEED2,IFILE,IFORMAT,
     +              IGDEGR,IGTGT,IGMWPC,IGPV,IGCALO,IGCOSM,IPMT,KUGEL,
     +              IPLANAR,IWEIGHT,ALPHA,A0,
     +              WCOSMIC(2),WGAMMA(2),WPOSITRON(2),WPISTOP(2),
     +              WPI_MUNU(2),WPI_MUNUG(2),WPI_ENU(2),WPI_ENUG(2),
     +              WPI_3ENU(2),WPI_E3NU(2),WPIBETA(2),WPI_MU2ENU(2),
     +              WMICHEL(2),WMU_E2NUG(2),WMU_3E2NU(2),WMU_3E(2),
     +              WMU_GE(2),WMU_E2G(2),WMUE_GG(2),WPIMP_NG(2),
     +              WPIMP_NGG(2),WPIMP_PI0N(2),WPIPP_PIPPI0P(2),
     +              WPIPP_PIPPIPN(2),WPIMP_PI0PI0N(2),
     +              WPIMP_PIMPI0P(2),WPIMP_PIMPIPN(2),
     +              EGAMMA(2),EPOSITRON(2),FBEAM,ZXCOSMIC(2),
     +              METHOD,IADCTDC,ICOINCID
*
      INTEGER       INTER,ISEQ,ISEED1,ISEED2,IFILE,IFORMAT,IGDEGR,
     +              IGTGT,IGMWPC,IGPV,IGCALO,IGCOSM,IPMT,KUGEL,
     +              IPLANAR,METHOD,IADCTDC,ICOINCID,IWEIGHT
      REAL          VERSION,WCOSMIC,WGAMMA,WPOSITRON,WPISTOP,WPI_MUNU,
     +              WPI_MUNUG,WPI_ENU,WPI_ENUG,WPI_3ENU,WPI_E3NU,
     +              WPIBETA,WPI_MU2ENU,WMICHEL,WMU_E2NUG,WMU_3E2NU,
     +              WMU_3E,WMU_GE,WMU_E2G,WMUE_GG,WPIMP_NG,WPIMP_NGG,
     +              WPIMP_PI0N,WPIPP_PIPPI0P,WPIPP_PIPPIPN,
     +              WPIMP_PI0PI0N,WPIMP_PIMPI0P,WPIMP_PIMPIPN,
     +              EGAMMA,EPOSITRON,FBEAM,ZXCOSMIC,Alpha,A0
*
*----------------------------------------------------------------------
*
      INTEGER NCHPART
      PARAMETER (NCHPART=20)
      COMMON/MWPC/EMWPC(2),WPC1(3,NCHPART),WPC2(3,NCHPART),
     +            IMWPC1(NCHPART),IMWPC2(NCHPART),NMWPC1,NMWPC2,
     +            NEWP1,NEWP2
      REAL EMWPC,WPC1,WPC2
      INTEGER IMWPC1,IMWPC2,NMWPC1,NMWPC2,NEWP1,NEWP2
*
*------------------------------------------------------------------------
*
      COMMON/GREACTION/ILEN,ILUX,ISTART,IHISTO,IMATRIX(30),
     + ICALHIT(5),IHCALL(30),IPARTICLE(5),IRAD(30),IREAC,SQME,SQME1,
     + SQME2,SQME3,RVEC(1),IACTSEED1,IACTSEED2
      REAL RVEC,SQME,SQME1,SQME2,SQME3
      INTEGER ILEN,ILUX,ISTART,IHISTO,IMATRIX,ICALHIT,IHCALL,
     + IPARTICLE,IREAC,IRAD,IACTSEED1,IACTSEED2
*
*------------------------------------------------------------------------
*
      COMMON/GBEAM/TINC(2),PINC(2),XYZSTOP(3),BEAM(8),
     +       ZBEAM,DIVBEAM(2),CTEMP(2),DX0,DY0,DZ0,DPX0,DPY0,
     +       POS_FRAC,MUO_FRAC,CONBEAM(2),VERTEX(3)
      REAL TINC,PINC,XYZSTOP,BEAM,ZBEAM,DIVBEAM,CTEMP,
     + DX0,DY0,DZ0,DPX0,DPY0,POS_FRAC,MUO_FRAC,CONBEAM,VERTEX
*
*------------------------------------------------------------------------
*
      COMMON/GENIN/NP,TECM,AMASS(18),KGENEV
      COMMON/GENOUT/PCM(5,18),WT
      COMMON/GENPART/IGHAD,HADFLAG,GAMFLAG,PI0FLAG,NEUFLAG,NR,
     +               PART(5,18,50),RBRANCH(50),IPHOTONUCLEAR,
     +               WEIGTHMAX(50),COUNTER(50)
      INTEGER IGHAD,HADFLAG,GAMFLAG,PI0FLAG,NEUFLAG,NP,KGENEV,NR,
     +               IPHOTONUCLEAR
      REAL TECM,AMASS,PCM,WT,PART,RBRANCH,WEIGTHMAX,COUNTER
*
*------------------------------------------------------------------------
*
      COMMON/PI0BLOCK/G1E,G1X,G1Y,G1Z,G2E,G2X,G2Y,G2Z
      REAL G1E,G1X,G1Y,G1Z,G2E,G2X,G2Y,G2Z
      INTEGER L100,L101,L111,NSDET
      PARAMETER (L100=113,L101=345,L111=61,NSDET=500)
      REAL MPP,MPR,MNE,MMU,MEP,MP0
      DATA MPP,MPR,MNE,MMU,MEP,MP0/0.13956995,0.93827231,
     +     0.93956563,0.105658389,0.00051099906,0.1349764/

      COMMON/NTPLES/XNTP100(L100),XNTP101(L101),XNTP111(L111),
     +              TAG100(L100),TAG101(L101),TAG111(L111)
      REAL XNTP100,XNTP101,XNTP111
      CHARACTER*15 TAG100,TAG101,TAG111

      COMMON/ELECTRONICS/EDEP(500),TDEP(500),NN240(7,240),ITDEP(500),
     +      RPMT(500),THRESHOLD(3),WADC,RCALO,CSIVECT(3),UNIFORMITY(2),
     +      ECSI,PHOTOELECTRON(2),CSITHT(240),CSIPHI(240),CSIANG(240),
     +      EDEPTOT,EDEPCAL,EDEPCAL1,EDEPCAL2,EDEPCAL3,EDEPNAI,EDEPNAV,
     +      EDEPNAIOUT,RPHOT0,RPHOT2,NGPHOTS,UNIF_VAL(-8:8,-8:8,1:24)
      REAL EDEP,TDEP,RPMT,THRESHOLD,WADC,RCALO,CSIVECT,UNIFORMITY,
     +     ECSI,PHOTOELECTRON,CSITHT,CSIPHI,CSIANG,EDEPTOT,EDEPCAL,
     +     EDEPCAL1,EDEPCAL2,EDEPCAL3,EDEPNAI,EDEPNAV,EDEPNAIOUT,
     +     RPHOT0,RPHOT2,UNIF_VAL
      INTEGER ITDEP,NGPHOTS,NN240

      INTEGER NCP
      PARAMETER (NCP=250)
      COMMON /CALOPAR/ IYEAR,FT_CSI_S(NCP),NP_CSI_S(NCP),TS_CSI_S(NCP),
     +   A1T_CSI_S(NCP),A2T_CSI_S(NCP),A1G_CSI_S(NCP),A2G_CSI_S(NCP),
     +   ID_CSI(NCP),M_CSI_S(NCP),ON_1993CSI_G(NCP),ON_1994CSI_G(NCP),
     +   ON_1995CSI_G(NCP),ON_1996CSI_G(NCP),ON_1997CSI_G(NCP),
     +   NO_1997CSI_G(NCP),NO_1997NAI_G(64),ON_2000CSI_G(NCP),
     +   ON_1998CSI_G(NCP),ON_1999CSI_G(NCP),
     +   G_CSI_G(NCP),GAIN_CSI_G(NCP),ERAND(400),EPILEUP,ON_CSI_G(NCP),
     +   ON_MAT(5),NP_CSI_G(NCP),A1T_CSI_G(NCP),A2T_CSI_G(NCP) 
      REAL*4 FT_CSI_S,NP_CSI_S,TS_CSI_S,A1T_CSI_S,A2T_CSI_S,A1G_CSI_S,
     +     A2G_CSI_S,ID_CSI,M_CSI_S,G_CSI_G,GAIN_CSI_G,ERAND,EPILEUP,
     +     NP_CSI_G,A1T_CSI_G,A2T_CSI_G 
      INTEGER*4 IYEAR,ON_1993CSI_G,ON_1994CSI_G,ON_1995CSI_G,
     +          ON_1996CSI_G,ON_1997CSI_G,NO_1997CSI_G,NO_1997NAI_G,
     +          ON_1998CSI_G,ON_1999CSI_G,ON_CSI_G,ON_MAT,ON_2000CSI_G
*
*------------------------------------------------------------------------
*
***********************************************************************
*
*       SRTMP stores global variables for temporary use during the
*       development process --SR
*
***********************************************************************
*
      COMMON/SRTMP/THISTO(240,500)

      REAL THISTO
*
*----------------------------------------------------------------------
*
*
***********************************************************************
*
*       JKTMP stores global variables for temporary use during the
*       development process --JK
*
***********************************************************************
*
      COMMON/SRTMP/VOLUNAME_LAST,CNUM_LAST,IDTYPE_LAST

      CHARACTER*4 VOLUNAME_LAST(15)
      INTEGER CNUM_LAST,IDTYPE_LAST
*
*----------------------------------------------------------------------
*
***********************************************************************
*
*       PSTMP stores global variables for temporary use during the
*       development process --PS
*
***********************************************************************
*
      COMMON/PSTMP/x_box,y_box,z_box,out_mat(3,3),rowmat(3),
     +             rotate,box_costh,box_sinth,box_cosph,
     +             box_sinph,box_theta(3),rel_ang1,rel_ang2,
     +             rel_ang3,box_phi(3),temp1,temp2,encsi,
     +             temp3, temp4, ennai, temp6,temp7,event_type,
     +             tcalo,tcnai,etype1,etype2

      REAL*4 x_box,y_box,z_box,out_mat,rowmat,box_costh,
     +      box_sinth,box_cosph,rel_ang1,rel_ang2,rel_ang3,
     +       box_sinph,box_theta,box_phi,temp1,temp2,encsi,
     +      temp3, temp4, ennai,
     +      temp6,temp7,tcalo,tcnai

        integer penny1
        real penny_mat(3,3),penny_temp(3)
        real penny_theta(3),penny_phi(3)

      INTEGER rotate,event_type,etype1,etype2
        real rach2(2) /12.01,1.01/
        real rzch2(2) /6.,1./
        real rpropch2(2) /1.,2./

        real ramyl(3) /12.01,1.01,16.00/
        real rzmyl(3) /6.,1.,8./
        real rpropmyl(3) /5.,4.,2./

        real rasz(2) /12.01,1.01/
        real rzsz(2) /6.,1./
        real rpropsz(2) /8.,8./

        real ranai(2) /22.99,126.9/
        real rznai(2) /11.,53./
        real rpropnai(2) /1.,1./

        real raca(1) /12.01/
        real rzca(1) /6./
        real rpropca(1) /1./

        real rvol(3) /12.,12.,12./               ! MARS
        real rdeg1(3) /.6,2.75,1./               ! carbon degrader 1
        real rsz(3) /.25,2.5,.75/                ! szintillator
        real rdeg2(3) /.45,2.75,1./              ! carbon degrader 2
        real rdeg3(3) /1.,1.75,4./               ! CH2 degrader
        real ralu(3) /6.0,6.1,5./                ! aluminium
        real rwin(3) /6.1,6.119,5./              ! Mylar window
        real riso(3) /0.,6.0,5./                 ! vacuum
        real rh1(3) /0.,2.,4./                   ! LH2 in target
        real rh2(3) /0.,.25,4./                  ! LH2 in pipe
        real rdo(3) /.25,.3,4./                  ! pipe
        real rdo2(3) /2.,2.015,4./               ! target
        real xsize, dmaxms, xpos                 ! C degrador size.
        
        integer ih21, ih22, ideg3
        integer isz, dedx, ivol, ideg1, ideg2
        integer ialu, iwin, iiso, ido, ido2

*
*----------------------------------------------------------------------
