      SUBROUTINE GEN_MUE_GG

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE MU+ E- --> G G EVENT
*
      NR=19

      NP=2
      KGENEV=1
      TECM=0.105658389+0.000510999
      AMASS(1)=0.0
      AMASS(2)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0
      R0=SQRT(X0*X0+Y0*Y0)

      CALL GENBOD
*     MATRIX ELEMENT SQUARED
      SQME=1.

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=1
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(2)=1
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(191001,'G1 PX',400,0.,70.0,0.)
        CALL HBOOK1(191002,'G1 PY',400,0.,70.0,0.)
        CALL HBOOK1(191003,'G1 PZ',400,0.,70.0,0.)
        CALL HBOOK1(191004,'G1 EN',400,0.,70.0,0.)
        CALL HBOOK1(192001,'G2 PX',400,0.,70.0,0.)
        CALL HBOOK1(192002,'G2 PY',400,0.,70.0,0.)
        CALL HBOOK1(192003,'G2 PZ',400,0.,70.0,0.)
        CALL HBOOK1(192004,'G2 EN',400,0.,70.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(191001,1000.*PCM(1,1),0.,WT)
        CALL HFILL(191002,1000.*PCM(2,1),0.,WT)
        CALL HFILL(191003,1000.*PCM(3,1),0.,WT)
        CALL HFILL(191004,1000.*PCM(4,1),0.,WT)
        CALL HFILL(192001,1000.*PCM(1,2),0.,WT)
        CALL HFILL(192002,1000.*PCM(2,2),0.,WT)
        CALL HFILL(192003,1000.*PCM(3,2),0.,WT)
        CALL HFILL(192004,1000.*PCM(4,2),0.,WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(191005,'X0 STOPPING COORDINATE',100,-3.0,3.0,0.)
        CALL HBOOK1(191006,'Y0 STOPPING COORDINATE',100,-3.0,3.0,0.)
        CALL HBOOK1(191007,'Z0 STOPPING COORDINATE',100,-3.0,3.0,0.)
        CALL HBOOK2
     +  (191008,'X0-Y0 STOPPING COORDINATES',50,-3.,3.,50,-3.,3.,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(191005,X0,0.,WT)
        CALL HFILL(191006,Y0,0.,WT)
        CALL HFILL(191007,Z0,0.,WT)
        CALL HFILL(191008,X0,Y0,WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0

      IHCALL(NR)=0

      RETURN
      END   

