      SUBROUTINE GEN_PIMP_PIMPIPN

*     08OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,P0,X0,Y0,Z0,R0,PLAB(3),UBUF(10),
     +     COSRA,RELANG,G1CTH,G1TH,G1PHI,
     +     G2CTH,G2TH,G2PHI,BX,BY,BZ,GAM
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI- P -> PI- PI+ N 
*     REFERENCE: 
*                
      NR=31

      NP=3

      P0=SQRT(TINC(1)*TINC(1)+2.*TINC(1)*MPR)

      TECM=SQRT(MPP*MPP+MPR*MPR+2.*(MPP+TINC(1))*MPR)
      KGENEV=1
      AMASS(1)=0.13956955
      AMASS(2)=0.13956955
      AMASS(3)=0.93956563
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED - CONSTANT
      SQME=1.

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=   PCM(4,1)
      IPARTICLE(1)=9
      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=   PCM(4,2)
      IPARTICLE(2)=8
      PART(1,2,NR)=PLAB(1)
      PART(2,2,NR)=PLAB(2)
      PART(3,2,NR)=PLAB(3)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=   PCM(4,3)
      IPARTICLE(3)=13
      PART(1,3,NR)=PLAB(1)
      PART(2,3,NR)=PLAB(2)
      PART(3,3,NR)=PLAB(3)
      PART(4,3,NR)=ELAB
      PART(5,3,NR)=PCM(5,3)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(261001,'PI-  PX',100,-80.0,80.0,0.)
        CALL HBOOK1(261002,'PI-  PY',100,-80.0,80.0,0.)
        CALL HBOOK1(261003,'PI-  PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(261004,'PI-  EN',100,  0.0,80.0,0.)
        CALL HBOOK1(262001,'PI+  PX',100,-80.0,80.0,0.)
        CALL HBOOK1(262002,'PI+  PY',100,-80.0,80.0,0.)
        CALL HBOOK1(262003,'PI+  PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(262004,'PI+  EN',100,  0.0,80.0,0.)
        CALL HBOOK1(263001,'N    PX',100,-80.0,80.0,0.)
        CALL HBOOK1(263002,'N    PY',100,-80.0,80.0,0.)
        CALL HBOOK1(263003,'N    PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(263004,'N    EN',100,  0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(261001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(261002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(261003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(261004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(262001,1000*PCM(1,2),0.,SQME*WT)
        CALL HFILL(262002,1000*PCM(2,2),0.,SQME*WT)
        CALL HFILL(262003,1000*PCM(3,2),0.,SQME*WT)
        CALL HFILL(262004,1000*PCM(4,2),0.,SQME*WT)
        CALL HFILL(263001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(263002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(263003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(263004,1000*PCM(4,3),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(261005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(261006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(261007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (261008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(261005,X0,0.,SQME*WT)
        CALL HFILL(261006,Y0,0.,SQME*WT)
        CALL HFILL(261007,Z0,0.,SQME*WT)
        CALL HFILL(261008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   


