
      DATA CALO/25.98,48.1,24.0,156.0,0.0,360.0/
      CALO(1)=RCALO*CALO(1)  ! Scale the calorimeter shell
      CALO(2)=CALO(1)+22.22
*
      CALL GSVOLU ('CALO','SPHE',2,CALO,6,ISTATUS)    ! Calorimeter mama, air
*
*       Position CsI modules in the calorimeter
*
      OPEN(UNIT=21,FILE='~/geant/geometry/pent.dat',STATUS='OLD')
      OPEN(UNIT=22,FILE='~/geant/geometry/hea.dat',STATUS='OLD')
      OPEN(UNIT=23,FILE='~/geant/geometry/heb.dat',STATUS='OLD')
      OPEN(UNIT=24,FILE='~/geant/geometry/hec.dat',STATUS='OLD')
      OPEN(UNIT=25,FILE='~/geant/geometry/hed.dat',STATUS='OLD')
      OPEN(UNIT=26,FILE='~/geant/geometry/hdh.dat',STATUS='OLD')
      OPEN(UNIT=27,FILE='~/geant/geometry/vet.dat',STATUS='OLD')
*
      do i=1,10
         READ(21,80) TP11,PP11,TP12,PP12,TP13,PP13
         CSITHT(I)=TP13
         CSIPHI(I)=PP13
80       FORMAT(2x,6f15.6)
*
	 TP21=180.0-TP11
	 PP21=PP11+180.0
	 TP22=180-TP12
	 PP22=PP12+180.0
	 TP23=TP13
	 PP23=PP13
	 if (pp21.gt.360.0) pp21=pp21-360.0
	 if (pp22.gt.360.0) pp22=pp22-360.0
*
         CALL GSROTM(i,TP11,PP11,TP12,PP12,TP13,PP13)
         CALL GSROTM(i+10,TP21,PP21,TP22,PP22,TP23,PP23)
*
*WL sind cosd to sin cos
         xp1=xp01*sin(dtor*tp11)*cos(dtor*pp11)+yp01*
     1       sin(dtor*tp12)*     
     1       cos(dtor*pp12)+zp01*sin(dtor*tp13)*cos(dtor*pp13)
         yp1=xp01*sin(dtor*tp11)*sin(dtor*pp11)+
     1       yp01*sin(dtor*tp12)*
     1       sin(dtor*pp12)+zp01*sin(dtor*tp13)*sin(dtor*pp13)
         zp1=xp01*cos(dtor*tp11)+yp01*cos(dtor*tp12)
     1       +zp01*cos(dtor*tp13)
*
         xp2=xp02*sin(dtor*tp21)*cos(dtor*pp21)
     1       +yp02*sin(dtor*tp22)*
     1       cos(dtor*pp22)+zp02*sin(dtor*tp23)*cos(dtor*pp23)
         yp2=xp02*sin(dtor*tp21)*sin(dtor*pp21)+
     1       yp02*sin(dtor*tp22)*
     1       sin(dtor*pp22)+zp02*sin(dtor*tp23)*sin(dtor*pp23)
         zp2=xp02*cos(dtor*tp21)+yp02*cos(dtor*tp22)
     1       +zp02*cos(dtor*tp23)
*
         CALL SCALE_RAD(RCALO,XP1,YP1,ZP1)
         CALL SCALE_RAD(RCALO,XP2,YP2,ZP2)

         IF(ON_CSI_G(I).NE.0) THEN
         CALL GSVOLU('P1'//CDE(I),'TRAP',10,PE1,11,ISTATUS) ! CsI
         CALL GSVOLU('P2'//CDE(I),'TRAP',10,PE2,11,ISTATUS)
         CALL GSPOS ('P1'//CDE(I),1,'CALO',xp1,yp1,zp1,i,   'ONLY')
         CALL GSDETV('P1','P1'//CDE(I),I,100,100,ISET,IDET)  ! 1->10
         CALL GSDETH('P1','P1'//CDE(I),2,NAMESH,NBITSH,ORIG,FACT)
         CALL GSPOS ('P2'//CDE(I),1,'CALO',xp2,yp2,zp2,i+10,'ONLY')
         CALL GSDETV('P2','P2'//CDE(I),I,100,100,ISET,IDET)  ! 1->10
         CALL GSDETH('P2','P2'//CDE(I),2,NAMESH,NBITSH,ORIG,FACT)
         IF (IPMT.EQ.1) CALL GSPOS('PMT1',I,'MAMA',
     +     1.514*xp1,1.514*yp1,1.514*zp1,I,'ONLY')! PMTs
         ENDIF
      enddo
*
       do i=21,70
         READ(22,100) TA11,PA11,TA21,PA21,TA31,PA31
         READ(22,100) TA12,PA12,TA22,PA22,TA32,PA32
         L=I-10
         CSITHT(L)=TA31
         CSIPHI(L)=PA31
*
         READ(23,100) TB11,PB11,TB21,PB21,TB31,PB31
         READ(23,100) TB12,PB12,TB22,PB22,TB32,PB32
         L=I+40
         CSITHT(L)=TB31
         CSIPHI(L)=PB31
*
         READ(24,100) TC11,PC11,TC21,PC21,TC31,PC31
         READ(24,100) TC12,PC12,TC22,PC22,TC32,PC32
         L=I+90
         CSITHT(L)=TC31
         CSIPHI(L)=PC31
*
      if (i.le.60) then
         READ(25,100) TD11,PD11,TD21,PD21,TD31,PD31
         READ(25,100) TD12,PD12,TD22,PD22,TD32,PD32
         L=I+140
         CSITHT(L)=TD31
         CSIPHI(L)=PD31
      else
         READ(26,100) TD11,PD11,TD21,PD21,TD31,PD31
         L=2*I+79
         CSITHT(L)=TD31
         CSIPHI(L)=PD31
         READ(26,100) TD12,PD12,TD22,PD22,TD32,PD32
         L=2*I+80
         CSITHT(L)=TD32
         CSIPHI(L)=PD32
         READ(27,100) TV11,PV11,TV21,PV21,TV31,PV31
         L=2*I+99
         CSITHT(L)=TV31
         CSIPHI(L)=PV31
         READ(27,100) TV12,PV12,TV22,PV22,TV32,PV32
         L=2*I+100
         CSITHT(L)=TV32
         CSIPHI(L)=PV32
*
         tv11=180.0-tv11
         pv11=180.0+pv11
         tv21=180.0-tv21
         pv21=180.0+pv21
*
         tv12=180.0-tv12
         pv12=180.0+pv12
         tv22=180.0-tv22
         pv22=180.0+pv22
      endif
*
100   format(2x,6f15.6)

*
*WL sind and cosd to sin and cos
      xa1=xa01*sin(dtor*ta11)*cos(dtor*pa11)
     1    +ya01*sin(dtor*ta21)*
     1    cos(dtor*pa21)+za01*sin(dtor*ta31)*cos(dtor*pa31)
      ya1=xa01*sin(dtor*ta11)*sin(dtor*pa11)
     1    +ya01*sin(dtor*ta21)*
     1    sin(dtor*pa21)+za01*sin(dtor*ta31)*sin(dtor*pa31)
      za1=xa01*cos(dtor*ta11)+ya01*cos(dtor*ta21)
     1    +za01*cos(dtor*ta31)
*
      xa2=xa02*sin(dtor*ta12)*cos(dtor*pa12)
     1    +ya02*sin(dtor*ta22)*
     1    cos(dtor*pa22)+za02*sin(dtor*ta32)*cos(dtor*pa32)
      ya2=xa02*sin(dtor*ta12)*sin(dtor*pa12)
     1    +ya02*sin(dtor*ta22)*
     1    sin(dtor*pa22)+za02*sin(dtor*ta32)*sin(dtor*pa32)
      za2=xa02*cos(dtor*ta12)+ya02*cos(dtor*ta22)
     1    +za02*cos(dtor*ta32)
*
      CALL SCALE_RAD(RCALO,XA1,YA1,ZA1)      
      CALL SCALE_RAD(RCALO,XA2,YA2,ZA2)      
*
*WL replace sind and cosd with sin and cos
      xb1=xb01*sin(dtor*tb11)*cos(dtor*pb11)+yb01*sin(dtor*tb21)*
     1    cos(dtor*pb21)+zb01*sin(dtor*tb31)*cos(dtor*pb31)
      yb1=xb01*sin(dtor*tb11)*sin(dtor*pb11)+yb01*sin(dtor*tb21)*
     1    sin(dtor*pb21)+zb01*sin(dtor*tb31)*sin(dtor*pb31)
      zb1=xb01*cos(dtor*tb11)+yb01*cos(dtor*tb21)+zb01*cos(dtor*tb31)
*
      xb2=xb02*sin(dtor*tb12)*cos(dtor*pb12)+yb02*sin(dtor*tb22)*
     1    cos(dtor*pb22)+zb02*sin(dtor*tb32)*cos(dtor*pb32)
      yb2=xb02*sin(dtor*tb12)*sin(dtor*pb12)+yb02*sin(dtor*tb22)*
     1    sin(dtor*pb22)+zb02*sin(dtor*tb32)*sin(dtor*pb32)
      zb2=xb02*cos(dtor*tb12)+yb02*cos(dtor*tb22)+zb02*cos(dtor*tb32)
*
      CALL SCALE_RAD(RCALO,XB1,YB1,ZB1)      
      CALL SCALE_RAD(RCALO,XB2,YB2,ZB2)      
*
*WL replace sind and cosd with sin and cos
      xc1=xc01*sin(dtor*tc11)*cos(dtor*pc11)
     1    +yc01*sin(dtor*tc21)*
     1    cos(dtor*pc21)+zc01*sin(dtor*tc31)*cos(dtor*pc31)
      yc1=xc01*sin(dtor*tc11)*sin(dtor*pc11)
     1    +yc01*sin(dtor*tc21)*
     1    sin(dtor*pc21)+zc01*sin(dtor*tc31)*sin(dtor*pc31)
      zc1=xc01*cos(dtor*tc11)+yc01*cos(dtor*tc21)
     1    +zc01*cos(dtor*tc31)
*
      xc2=xc02*sin(dtor*tc12)*cos(dtor*pc12)
     1    +yc02*sin(dtor*tc22)*
     1    cos(dtor*pc22)+zc02*sin(dtor*tc32)*cos(dtor*pc32)
      yc2=xc02*sin(dtor*tc12)*sin(dtor*pc12)
     1    +yc02*sin(dtor*tc22)*
     1    sin(dtor*pc22)+zc02*sin(dtor*tc32)*sin(dtor*pc32)
      zc2=xc02*cos(dtor*tc12)+yc02*cos(dtor*tc22)
     1    +zc02*cos(dtor*tc32)
*
      CALL SCALE_RAD(RCALO,XC1,YC1,ZC1)      
      CALL SCALE_RAD(RCALO,XC2,YC2,ZC2)      
*
      if (i.gt.60) then
        yd01=-2.2295
        yd02=-2.2295
        xd01=-0.1117
        xd02=0.1117
        endif 
*WL replace sind and cosd with sin and cos
      xd1=xd01*sin(dtor*td11)*cos(dtor*pd11)
     1    +yd01*sin(dtor*td21)*
     1    cos(dtor*pd21)+zd01*sin(dtor*td31)*cos(dtor*pd31)
      yd1=xd01*sin(dtor*td11)*sin(dtor*pd11)
     1    +yd01*sin(dtor*td21)*
     1    sin(dtor*pd21)+zd01*sin(dtor*td31)*sin(dtor*pd31)
      zd1=xd01*cos(dtor*td11)+yd01*cos(dtor*td21)
     1    +zd01*cos(dtor*td31)
*
      xd2=xd02*sin(dtor*td12)*cos(dtor*pd12)
     1    +yd02*sin(dtor*td22)*
     1    cos(dtor*pd22)+zd02*sin(dtor*td32)*cos(dtor*pd32)
      yd2=xd02*sin(dtor*td12)*sin(dtor*pd12)
     1    +yd02*sin(dtor*td22)*
     1    sin(dtor*pd22)+zd02*sin(dtor*td32)*sin(dtor*pd32)
      zd2=xd02*cos(dtor*td12)+yd02*cos(dtor*td22)
     1    +zd02*cos(dtor*td32)
*
      CALL SCALE_RAD(RCALO,XD1,YD1,ZD1)      
      CALL SCALE_RAD(RCALO,XD2,YD2,ZD2)      
*
      j=i+50

      if (i.gt.60) then 
          k=i-60
          CALL GSROTM(k+420,TV11,PV11,TV21,PV21,TV31,PV31)
          CALL GSROTM(k+430,TV12,PV12,TV22,PV22,TV32,PV32)
*
*WL replace sind and cosd with sin and cos
          xv1=xv01*sin(dtor*tv11)*cos(dtor*pv11)
     1        +yv01*sin(dtor*tv21)*
     1        cos(dtor*pv21)+zv01*sin(dtor*tv31)*cos(dtor*pv31)
          yv1=xv01*sin(dtor*tv11)*sin(dtor*pv11)
     1         +yv01*sin(dtor*tv21)*
     1         sin(dtor*pv21)+zv01*sin(dtor*tv31)*sin(dtor*pv31)
          zv1=xv01*cos(dtor*tv11)+yv01*cos(dtor*tv21)
     1        +zv01*cos(dtor*tv31)
*
          xv2=xv02*sin(dtor*tv11)*cos(dtor*pv11)
     1         +yv02*sin(dtor*tv21)*
     1         cos(dtor*pv21)+zv02*sin(dtor*tv31)*cos(dtor*pv31)
          yv2=xv02*sin(dtor*tv11)*sin(dtor*pv11)
     1         +yv02*sin(dtor*tv21)*
     1         sin(dtor*pv21)+zv02*sin(dtor*tv31)*sin(dtor*pv31)
          zv2=xv02*cos(dtor*tv11)+yv02*cos(dtor*tv21)
     1         +zv02*cos(dtor*tv31)
*
      CALL SCALE_RAD(RCALO,XV1,YV1,ZV1)      
      CALL SCALE_RAD(RCALO,XV2,YV2,ZV2)      
*
*WL replace sind and cosd with sin and cos
          xv3=xv03*sin(dtor*tv12)*cos(dtor*pv12)
     1         +yv03*sin(dtor*tv22)*
     1         cos(dtor*pv22)+zv03*sin(dtor*tv32)*cos(dtor*pv32)
          yv3=xv03*sin(dtor*tv12)*sin(dtor*pv12)
     1         +yv03*sin(dtor*tv22)*
     1         sin(dtor*pv22)+zv03*sin(dtor*tv32)*sin(dtor*pv32)
          zv3=xv03*cos(dtor*tv12)+yv03*cos(dtor*tv22)
     1         +zv03*cos(dtor*tv32)
*
          xv4=xv04*sin(dtor*tv12)*cos(dtor*pv12)
     1         +yv04*sin(dtor*tv22)*
     1         cos(dtor*pv22)+zv04*sin(dtor*tv32)*cos(dtor*pv32)
          yv4=xv04*sin(dtor*tv12)*sin(dtor*pv12)
     1         +yv04*sin(dtor*tv22)*
     1         sin(dtor*pv22)+zv04*sin(dtor*tv32)*sin(dtor*pv32)
          zv4=xv04*cos(dtor*tv12)+yv04*cos(dtor*tv22)
     1         +zv04*cos(dtor*tv32)
*
      CALL SCALE_RAD(RCALO,XV3,YV3,ZV3)      
      CALL SCALE_RAD(RCALO,XV4,YV4,ZV4)      
*
      endif
*
      CALL GSROTM(i,TA11,PA11,TA21,PA21,TA31,PA31)
      CALL GSROTM(j,TA12,PA12,TA22,PA22,TA32,PA32)
*
      CALL GSROTM(i+100,TB11,PB11,TB21,PB21,TB31,PB31)
      CALL GSROTM(j+100,TB12,PB12,TB22,PB22,TB32,PB32)
*
      CALL GSROTM(i+200,TC11,PC11,TC21,PC21,TC31,PC31)
      CALL GSROTM(j+200,TC12,PC12,TC22,PC22,TC32,PC32)
*
      CALL GSROTM(i+300,TD11,PD11,TD21,PD21,TD31,PD31)
      CALL GSROTM(j+300,TD12,PD12,TD22,PD22,TD32,PD32)
*
      IF(ON_CSI_G(I-10).NE.0) THEN
      CALL GSVOLU('A1'//CDE(I-20),'TRAP',10,HA1,11,ISTATUS)
      CALL GSVOLU('A2'//CDE(I-20),'TRAP',10,HA2,11,ISTATUS)
      CALL GSPOS ('A1'//CDE(I-20),1,'CALO',xa1,ya1,za1,i,'ONLY')
      CALL GSDETV('A1','A1'//CDE(I-20),I-10,100,100,ISET,IDET)  ! 11->60
      CALL GSDETH('A1','A1'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
      CALL GSPOS ('A2'//CDE(I-20),1,'CALO',xa2,ya2,za2,j,'ONLY')
      CALL GSDETV('A2','A2'//CDE(I-20),I-10,100,100,ISET,IDET)  ! 11->60
      CALL GSDETH('A2','A2'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
      IF (IPMT.EQ.1) CALL GSPOS('PMT1',I-10,'MAMA',
     +  1.514*xa1,1.514*ya1,1.514*za1,I,'ONLY')! PMTs
      ENDIF
*
      IF(ON_CSI_G(I+40).NE.0) THEN
      CALL GSVOLU('B1'//CDE(I-20),'TRAP',10,HB1,11,ISTATUS)
      CALL GSVOLU('B2'//CDE(I-20),'TRAP',10,HB2,11,ISTATUS)
      CALL GSPOS ('B1'//CDE(I-20),1,'CALO',xb1,yb1,zb1,i+100,'ONLY')
      CALL GSDETV('B1','B1'//CDE(I-20),I+40,100,100,ISET,IDET)  ! 61->110
      CALL GSDETH('B1','B1'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
      CALL GSPOS ('B2'//CDE(I-20),1,'CALO',xb2,yb2,zb2,j+100,'ONLY')
      CALL GSDETV('B2','B2'//CDE(I-20),I+40,100,100,ISET,IDET)  ! 61->110
      CALL GSDETH('B2','B2'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
      IF (IPMT.EQ.1) CALL GSPOS ('PMT1',I+40,'MAMA',
     +  1.514*xb1,1.514*yb1,1.514*zb1,I+100,'ONLY')! PMTs
      ENDIF
*
      IF(ON_CSI_G(I+90).NE.0) THEN
      CALL GSVOLU('C1'//CDE(I-20),'TRAP',10,HC1,11,ISTATUS)
      CALL GSVOLU('C2'//CDE(I-20),'TRAP',10,HC2,11,ISTATUS)
      CALL GSPOS ('C1'//CDE(I-20),1,'CALO',xc1,yc1,zc1,i+200,'ONLY')
      CALL GSDETV('C1','C1'//CDE(I-20),I+90,100,100,ISET,IDET)  ! 111->160
      CALL GSDETH('C1','C1'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
      CALL GSPOS ('C2'//CDE(I-20),1,'CALO',xc2,yc2,zc2,j+200,'ONLY')
      CALL GSDETV('C2','C2'//CDE(I-20),I+90,100,100,ISET,IDET)  ! 111->160
      CALL GSDETH('C2','C2'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
      IF (IPMT.EQ.1) CALL GSPOS('PMT1',I+90,'MAMA',
     +  1.514*xc1,1.514*yc1,1.514*zc1,I+200,'ONLY')! PMTs
      ENDIF
*
      if (i.le.60) then
        IF(ON_CSI_G(I+140).NE.0) THEN
        CALL GSVOLU('D1'//CDE(I-20),'TRAP',10,HD1,11,ISTATUS)
        CALL GSVOLU('D2'//CDE(I-20),'TRAP',10,HD2,11,ISTATUS)
        CALL GSPOS ('D1'//CDE(I-20),1,'CALO',xd1,yd1,zd1,i+300,'ONLY')
        CALL GSDETV('D1','D1'//CDE(I-20),I+140,100,100,ISET,IDET)  ! 161->200
        CALL GSDETH('D1','D1'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
        CALL GSPOS ('D2'//CDE(I-20),1,'CALO',xd2,yd2,zd2,j+300,'ONLY')
        CALL GSDETV('D2','D2'//CDE(I-20),I+140,100,100,ISET,IDET)  ! 161->200
        CALL GSDETH('D2','D2'//CDE(I-20),2,NAMESH,NBITSH,ORIG,FACT)
      IF (IPMT.EQ.1) CALL GSPOS('PMT1',I+140,'MAMA',
     +  1.514*xd1,1.514*yd1,1.514*zd1,I+100,'ONLY')! PMTs
        ENDIF
      else
C       HEX-DHALF-1
        IF(ON_CSI_G(IHDH1(I-60)).NE.0) THEN
        CALL GSVOLU('H1'//CDE(I-60),'TRAP',10,HH1,11,ISTATUS)
        CALL GSPOS ('H1'//CDE(I-60),1,'CALO',xd1,yd1,zd1,i+300,'ONLY')
        CALL GSDETV('H1','H1'//CDE(I-60),IHDH1(I-60),100,100,ISET,IDET) ! 201->210
        CALL GSDETH('H1','H1'//CDE(I-60),2,NAMESH,NBITSH,ORIG,FACT)
        ENDIF
C       HEX-DHALF-2
        IF(ON_CSI_G(IHDH2(I-60)).NE.0) THEN        
        CALL GSVOLU('H2'//CDE(I-60),'TRAP',10,HH2,11,ISTATUS)
        CALL GSPOS ('H2'//CDE(I-60),1,'CALO',xd2,yd2,zd2,j+300,'ONLY')
        CALL GSDETV('H2','H2'//CDE(I-60),IHDH2(I-60),100,100,ISET,IDET) ! 211->220
        CALL GSDETH('H2','H2'//CDE(I-60),2,NAMESH,NBITSH,ORIG,FACT)
        ENDIF

C       VETO 11,12,21,22
        IV=I-60
*
        IF(ON_CSI_G(I+160).NE.0) THEN                
        CALL GSVOLU('V1'//CDE(I-60),'TRAP',10,VT1,11,ISTATUS)
        CALL GSPOS ('V1'//CDE(I-60),1,'CALO',xv1,yv1,zv1,iv+420,'ONLY')
        CALL GSDETV('V1','V1'//CDE(I-60),I+160,100,100,ISET,IDET)  ! 221->230
        CALL GSDETH('V1','V1'//CDE(I-60),2,NAMESH,NBITSH,ORIG,FACT)
        CALL GSVOLU('V2'//CDE(I-60),'TRAP',10,VT2,11,ISTATUS)
        CALL GSPOS ('V2'//CDE(I-60),1,'CALO',xv2,yv2,zv2,iv+420,'ONLY')
        CALL GSDETV('V2','V2'//CDE(I-60),I+160,100,100,ISET,IDET)  ! 221->230
        CALL GSDETH('V2','V2'//CDE(I-60),2,NAMESH,NBITSH,ORIG,FACT)
        ENDIF
*
        IF(ON_CSI_G(I+170).NE.0) THEN                
        CALL GSVOLU('V3'//CDE(I-60),'TRAP',10,VT3,11,ISTATUS)
        CALL GSPOS ('V3'//CDE(I-60),1,'CALO',xv3,yv3,zv3,iv+430,'ONLY')
        CALL GSDETV('V3','V3'//CDE(I-60),I+170,100,100,ISET,IDET)  ! 231->240
        CALL GSDETH('V3','V3'//CDE(I-60),2,NAMESH,NBITSH,ORIG,FACT)
        CALL GSVOLU('V4'//CDE(I-60),'TRAP',10,VT4,11,ISTATUS)
        CALL GSPOS ('V4'//CDE(I-60),1,'CALO',xv4,yv4,zv4,iv+430,'ONLY')
        CALL GSDETV('V4','V4'//CDE(I-60),I+170,100,100,ISET,IDET)  ! 231->240
        CALL GSDETH('V4','V4'//CDE(I-60),2,NAMESH,NBITSH,ORIG,FACT)
        ENDIF
*
      endif
*
      enddo
*
*-----------------------------------------------------------------------
*
c      OPEN(UNIT=28,FILE='~/geant/geometry/csi_ang.dat',STATUS='OLD')
c      WRITE (6,*) ' '
c      WRITE (6,*) 
c     +' Reading CsI modules weighted directions from MC file...'
c       DO I=1,240
c        READ(28,*)  
c       ENDDO
*
c     close(28)
*-----------------------------------------------------------------------

*       Close data files
*
      close(21)
      close(22)
      close(23)
      close(24)
      close(25)
      close(26)
      close(27)
