c	subroutine ugeom
C============================================================================
C description of the LH2-Target setup
C============================================================================

        xsize=0.45                ! C degrador size.

	rdeg2(1) = xsize
	xpos = 6.95 - (xsize - .45)

	call gsvolu('MARS','BOX ',1,rvol,3,ivol)  ! vaccuum

	call gsvolu('Deg1','BOX ',5,rdeg1,3,ideg1) ! C
	call gsvolu('Szin','BOX ',3,rsz,3,isz)     ! Scint. 
	call gsvolu('Deg2','BOX ',5,rdeg2,3,ideg2) ! C
	call gsvolu('Deg3','BOX ',5,rdeg3,3,ideg3)! C
	call gsvolu('Walu','TUBE',17,ralu,3,ialu)   ! Alu
	call gsvolu('Wind','TUBE',6,rwin,3,iwin)   ! Mylar
	call gsvolu('Isol','TUBE',1,riso,3,iiso)   ! Vaccuum
	call gsvolu('Hyd1','TUBE',18,rh1,3,ih21)    ! LH2
	call gsvolu('Hyd2','TUBE',18,rh2,3,ih22)    ! LH2
	call gsvolu('Dos1','TUBE',12,rdo,3,ido)     ! Fe
	call gsvolu('Dos2','TUBE',6,rdo2,3,ido2)   ! Mylar

        penny_mat(1,1)=0.7801
        penny_mat(1,2)=-0.4470
        penny_mat(1,3)=-0.4378
        penny_mat(2,1)=0.4894
        penny_mat(2,2)=0.0
        penny_mat(2,3)=0.8721
        penny_mat(3,1)=-0.3898
        penny_mat(3,2)=-0.8945
        penny_mat(3,3)=0.2187


        do 10 penny1=1,3
          penny_temp(1)=penny_mat(penny1,1)
          penny_temp(2)=penny_mat(penny1,2)
          penny_temp(3)=penny_mat(penny1,3)
          call gfang(penny_temp,costh,sinth,cosph,sinph,rotate)
*WL use atan2 instead of atan2d,
          penny_theta(penny1) = atan2(sinth,costh)/dtor
          penny_phi(penny1) = atan2(sinph,cosph)/dtor
 10     continue

c	call gsrotm(777,115.95,29.87,150.70,180.00,77.34,113.59)
	call gsrotm(777,penny_theta(1),penny_phi(1),penny_theta(2),
     +       penny_phi(2),penny_theta(3),penny_phi(3))
        call gsrotm(998,90.,0.,0.,0.,90.,90.)  

	call gspos('Hyd1',1,'Isol',0.,0.,0.,0,'ONLY')
	call gspos('Hyd2',1,'Isol',-2.5,0.,0.,0,'ONLY')
	call gspos('Dos1',1,'Isol',-2.5,0.,0.,0,'ONLY')
	call gspos('Dos2',1,'Isol',0.,0.,0.,0,'ONLY')
	call gspos('Deg3',1,'Isol',3.1,0.,0.,0,'ONLY')

	call gspos('Isol',1,'MARS',0.,0.,0.,998,'ONLY')
	call gspos('Wind',1,'MARS',0.,0.,0.,998,'ONLY')
	call gspos('Walu',1,'MARS',0.,0.,0.,998,'ONLY')

	call gspos('Deg1',1,'MARS',8.70,0.,0.,0,'ONLY')
	call gspos('Szin',1,'MARS',7.75,0.,0.,0,'ONLY')
	call gspos('Deg2',1,'MARS',xpos,0.,0.,0,'ONLY')

c        call gspos('MARS',1,'MAMA',0.,0.,0.,0,'ONLY')
        call gspos('MARS',1,'MAMA',0.,0.,0.,777,'ONLY')
 

C make MARS invisible
	call gsatt('MARS','SEEN',0)

C close geometry definition
c	call ggclos



