************************************************************************    
*
       SUBROUTINE HISTOS
*
*
*      History
*      -------
*
*      111095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'
      COMMON/QUEST/IQUEST(100)
      INTEGER IQUEST,I
*
      CALL HBOOK1(201,'CsI CALO Hits',  240,0.,240.,0.)
      CALL HBOOK1(202,'CsI CALO Energy',240,0.,240.,0.)
      CALL HBOOK1(203,'CsI CALO Timing',240,0.,240.,0.)

      CALL HBOOK1(204,'PVETO Hits',  20,0.,20.,0.)
      CALL HBOOK1(205,'PVETO Energy',20,0.,20.,0.)
      CALL HBOOK1(206,'PVETO Timing',20,0.,20.,0.)

      CALL HBOOK1(207,'TGT Hits',  69,0.,69.,0.)
      CALL HBOOK1(208,'TGT Energy',69,0.,69.,0.)
      CALL HBOOK1(209,'TGT Timing',69,0.,69.,0.)

      CALL HBOOK1(210,'CALO Triggers',50,0.,50.,0.)
      CALL HBOOK1(211,'Total Weight',100,-1.E6,1.E6,0.)

C--   CsI CALO Hits plotted as PHI vs THETA
      CALL HBOOK2(212,'CALO Pile-Up',380,-10.,370.,
     +            180,20.,160.,0.)

C--   Generic COUNTERS
      CALL HBOOK1(213,'Counter Flags',50,0.,50.,0.)

C--   Acceptance vs THT1 (thrown, measured)
      CALL HBOOK1(214,'Acceptance vs THT1_THR',200,-1.,1.,0.)
      CALL HBOOK1(215,'Acceptance vs THT1_MEA',200,-1.,1.,0.)
      CALL HBOOK1(216,'Acceptance vs THT1 NORM Histo',180,0.,180.,0.)
      CALL HBOOK1(218,'Acceptance vs THT1_THR NORM',200,-1.,1.,0.)
      CALL HBOOK1(219,'Acceptance vs THT1_MEA NORM',200,-1.,1.,0.)
      CALL HBOOK1(220,'Acceptance vs THT1_THT NUM',200,-1.,1.,0.)
C--   THT1_THR-THT1_MEA
      CALL HBOOK1(217,'THT1_THR-THT1_MEA',360,-180.,180.,0.)

* ying add histo 230 
      CALL HBOOK1(230,'target0 energy',25,0.,5.,0.)
      CALL HBOOK1(231,'target1 energy',25,0.,5.,0.)
      CALL HBOOK1(232,'target2 energy',25,0.,5.,0.)
      CALL HBOOK1(233,'target3 energy',25,0.,5.,0.)
      CALL HBOOK1(234,'target4 energy',25,0.,5.,0.)
      CALL HBOOK1(235,'target5 engery',25,0.,5.,0.)
      CALL HBOOK1(236,'target6 engery',25,0.,5.,0.)
      CALL HBOOK1(237,'target7 engery',25,0.,5.,0.)
      CALL HBOOK1(238,'target8 engery',25,0.,5.,0.)
*ying add end
C--   Multiple Coincidence Histograms
      IF (ICOINCID.EQ.2) THEN
        CALL HBOOK1(310,'CALO Triggers, 2 EVENTS',50,0.,50.,0.)
        CALL HBOOK1(311,'Total Weight, 2 EVENTS',100,-1.E6,1.E6,0.)
      ELSEIF (ICOINCID.EQ.3) THEN
        CALL HBOOK1(410,'CALO Triggers, 3 EVENTS',50,0.,50.,0.)
        CALL HBOOK1(411,'Total Weight, 3 EVENTS',100,-1.E6,1.E6,0.)
      ELSEIF (ICOINCID.EQ.4) THEN
        CALL HBOOK1(510,'CALO Triggers, 4 EVENTS',50,0.,50.,0.)
        CALL HBOOK1(511,'Total Weight, 4 EVENTS',100,-1.E6,1.E6,0.)        
      ENDIF

C--   Photon interacts
      CALL HBOOK1(601,'First Photon interaction',500,0.,50.,0.)
      CALL HBOOK1(602,'First Photon deposits 2 MeV',500,0.,50.,0.)

C--   Radial Shower Profiles, THROWN & RECONSTRUCTED1,2, per angle and perAREA
      CALL HBOOK1(701,'Rad Show Prof EDEP THR',180,0.,180.,0.)
      CALL HBOOK1(702,'Rad Show R    EDEP THR',180,0.,180.,0.)
      CALL HBOOK1(704,'Rad Show EDEP_dcos THR',80,0.9,1.,0.)
      CALL HBOOK1(705,'Rad Show R_dcos    THR',80,0.9,1.,0.)
c
      CALL HBOOK1(721,'Rad Show Prof EDEP REC1',180,0.,180.,0.)
      CALL HBOOK1(722,'Rad Show R    EDEP REC1',180,0.,180.,0.)
      CALL HBOOK1(723,'Rad Show Prof EDEP REC2',180,0.,180.,0.)
      CALL HBOOK1(724,'Rad Show R    EDEP REC2',180,0.,180.,0.)
      CALL HBOOK1(725,'Rad Show EDEP_dcos REC1',80,0.9,1.,0.)
      CALL HBOOK1(726,'Rad Show EDEP_dcos REC2',80,0.9,1.,0.)
c
      CALL HBOOK1(731,'Rad Show Prof EDEP/EMAX REC1',180,0.,180.,0.)
      CALL HBOOK1(732,'Rad Show perA EDEP/EMAX REC1',180,0.,180.,0.)
      CALL HBOOK1(733,'Rad Show Prof EDEP/EMAX REC2',180,0.,180.,0.)
      CALL HBOOK1(734,'Rad Show perA EDEP/EMAX REC2',180,0.,180.,0.)
      CALL HBOOK1(735,'Rad Show EDEP/EMAX_dcos REC1',80,0.9,1.,0.)
      CALL HBOOK1(736,'Rad Show EDEP/EMAX_dcos REC2',80,0.9,1.,0.)
C
C--   Bump Discriminator Functions
C
      CALL HBOOK2(741,'Bump Discr REC1',110,
     +            -0.05,1.05,240,-5.,55.,0.)
      CALL HBOOK2(742,'Bump Discr REC2',110,
     +            -0.05,1.05,240,-5.,55.,0.)

      CALL HBOOK2(743,'CLAMP12 Discriminator',160,
     +                   -0.05,1.55,380,-5.,185.,0.)
      CALL HBOOK2(744,'CLAMP13 Discriminator',160,
     +                   -0.05,1.55,380,-5.,185.,0.)
      CALL HBOOK2(745,'CLAMP23 Discriminator',160,
     +                   -0.05,1.55,380,-5.,185.,0.)

      CALL HBOOK2(746,'Single Particle Discriminator',160,
     +                   -0.05,1.55,380,-5.,185.,0.)

C--   Reference CsI histograms: module with max energy + nearest neighbours
      DO I=1,242
C--     NEAREST NEIGHBOR energy Histograms (4, 5, 6, or 7 crystals)
C--     IDN=x241, average over ID=1-200, IDN=x242, average over 1-240
        CALL HBOOK1
     +  (1000+I,'REF CSI: NEAREST NEIGHBOR Es',1400,0.,140.,0.)
        CALL HBOOK1
     +  (1500+I,'REF CSI: NEAREST NEIGH Es EVle5',1400,0.,140.,0.) 
C--     Just the deposited energy if crystal has highest energy deposition
        CALL HBOOK1
     +  (2000+I,'REF CSI: ONLY MAX SINGLE Es',1400,0.,140.,0.) 
C--     Average deposited energy in I-th crystal (if EDEP(I)>0)
        CALL HBOOK1
     +  (3000+I,'REF CSI: ALL NONZERO SINGLE Es',1400,0.,140.,0.) 
      ENDDO

        CALL HBOOK1
     +  (1243,'CSI_MAX_HIT',240,0.,240.,0.)

      DO I=1,61
C--     Clusters energy Histograms 1->61 (61=any CLUSTER)
        CALL HBOOK1
     +  (4000+I,'REF CSI: SINGLE CLUSTER ADCs',1400,0.,140.,0.) 
        CALL HBOOK1
     +  (4500+I,'REF CSI: SINGLE CLU ADCs EVle5',1400,0.,140.,0.) 
C--     Clusters energy Histograms 1->61 (61=any CLUSTER)
        CALL HBOOK1
     +  (5000+I,'REF CSI: MAX CLUSTER ADCs',1400,0.,140.,0.) 
C--     Clusters timing Histograms 1->61 (61=any CLUSTER)
        CALL HBOOK1
     +  (6000+I,'REF CSI: MAX CLUSTER TDCs',1000,0.,100.,0.) 
      ENDDO

C--  book histos for pibeta events
      CALL HBOOK1(200000,'G-G ANGLE', 185, 0, 185, 0.)
      CALL HBOOK1(200001,'G+G ENERGY', 300, 0., 300., 0.)
      CALL HBOOK1(200002,'GG TIMING DIFFERENCE', 40, -10., 10, 0.)
      CALL HBOOK2(200003,'THT VS. PHI OF G1', 180,0.,180.,180,0.,
     +            180.,0.)
      CALL HBOOK1(200004,'THT OF G1', 180, 0., 180., 0.)
      CALL HBOOK1(200005,'PHI OF G1', 180, 0., 180., 0.)
      CALL HBOOK1(200009, 'ANGLE DIF', 180, 0., 180.,0.)
      CALL HBOOK1(200010,'ANGLE DIFF,WEIGHTED Y', 180.,0.,180.,0.)

      CALL HBOOK1(960002,'LA1-LA2 tr0',120,-0.2,0.2,0.)      
      CALL HBOOK1(960003,'LA1-LA2 tr2',120,-0.2,0.2,0.)

      RETURN
      END   

************************************************************************    
*
       SUBROUTINE FILLHISTOS
*
*
*      History
*      -------
*
*      111095 EF created
*
************************************************************************    
*
      IMPLICIT NONE
*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end

      COMMON /FCLUSTER/CC(9,60),SCC(6,10),CADC(60),CTDC(60),
     +       FIREDL(60),FIREDH(60),BFIREDL(60),BFIREDH(60),
     +       NFIREDL,NFIREDH,SFIREDL(10),SFIREDH(10),
     +       BSFIREDL(10),BSFIREDH(10),NSFIREDL,
     +       NSFIREDH,CLTHT(60),CLPHI(60),THT12,HTRIGGER(50),
     +       LTRIGGER(50),ICLUST,THT1,PHI1,TDC1,TDC2

      REAL CADC,CTDC,THT1,PHI1,THT2,THT3,THT12,CLTHT,CLPHI,THTT,
     +     TDC1,TDC2
      INTEGER CC,SCC,FIREDL,FIREDH,BFIREDL,BFIREDH,NFIREDL,
     +        NFIREDH,SFIREDL,SFIREDH,BSFIREDL,BSFIREDH,NSFIREDL,
     +        NSFIREDH,HTRIGGER,LTRIGGER,ICLUST
      REAL SHOWERPHI,SHOWERRHO,CSIOPEN,CSIOFF
       
      INCLUDE '../common.inc'

      COMMON/SUPERDEP/EDEPS(10),GA1D,GA2D,IGA1D,IGA2D,THTC
      REAL EDEPS,GA1D,GA2D,THTC
      INTEGER IGA1D,IGA2D 

      COMMON/CLUMPS/EDEP_CL1,EDEP_CL2,EDEP_CL3,
     +              THT_B12,THT_B13,THT_B23,
     +              SHARE12,SHARE13,SHARE23,PSQ,LAMM
      REAL EDEP_CL1,EDEP_CL2,EDEP_CL3,
     +     THT_B12,THT_B13,THT_B23,
     +     SHARE12,SHARE13,SHARE23,PSQ,LAMM 

      COMMON/IND_MCSI/I_MAX1,I_MAX2,I_MAX3
      INTEGER I_MAX1,I_MAX2,I_MAX3

      COMMON/QUEST/IQUEST(100)
      INTEGER I,J,IQUEST,IECSIMAX,IECLUMAX
      REAL INDTMP,ETARGET,ECSIMAX,ECLUMAX,EDEPVT,R
      REAL NN200(7,200),NN40(7,40)
      INCLUDE '../electronics/neighbors.f'

      IF((WT*SQME).LE.0.) RETURN

C Target Profile
*ying add to fill histo 230
*      IF(EDEP(261).GT.0) CALL HFILL(230,EDEP(261),0.,1.)
      IF(EDEP(262).GT.0.AND.EDEP(264).GT.0
     + .AND.EDEP(263).EQ.0.AND.EDEP(265).EQ.0)
     +   CALL HFILL(230,EDEP(261),0.,1.)
*      IF(EDEP(262).GT.0) CALL HFILL(231,EDEP(262),0.,1.)
      IF(EDEP(261).GT.0.AND.EDEP(264).GT.0
     + .AND.EDEP(263).EQ.0.AND.EDEP(265).EQ.0)
     +   CALL HFILL(231,EDEP(262),0.,1.)
      IF(EDEP(263).GT.0) CALL HFILL(232,EDEP(263),0.,1.)
*      IF(EDEP(264).GT.0) CALL HFILL(233,EDEP(264),0.,1.)
      IF(EDEP(261).GT.0.AND.EDEP(262).GT.0
     + .AND.EDEP(263).EQ.0.AND.EDEP(265).EQ.0)
     +  CALL  HFILL(233,EDEP(264),0.,1.)
      IF(EDEP(265).GT.0) CALL HFILL(234,EDEP(265),0.,1.)
      IF(EDEP(266).GT.0) CALL HFILL(235,EDEP(266),0.,1.)
      IF(EDEP(267).GT.0) CALL HFILL(236,EDEP(267),0.,1.)
      IF(EDEP(268).GT.0) CALL HFILL(237,EDEP(268),0.,1.)
      IF(EDEP(269).GT.0) CALL HFILL(238,EDEp(269),0.,1.)
*ying add end
      R=-1000.
      IF(EDEP(261).GT.4.5.AND.
     .(EDEP(262)+EDEP(263)+EDEP(264)+EDEP(265)).GT.4.5) 
     . R=(EDEP(262)+EDEP(263)+EDEP(264)+EDEP(265))/EDEP(261)
       CALL HFILL(41011,R,0.,WT*SQME)
       R=-1000.
      IF(EDEP(262)+EDEP(263)+EDEP(264)+EDEP(265).GT.4.5.AND.
     .(EDEP(266)+EDEP(267)+EDEP(268)+EDEP(269)).GT.4.5)
     . R=(EDEP(266)+EDEP(267)+EDEP(268)+EDEP(269))/
     . (EDEP(262)+EDEP(263)+EDEP(264)+EDEP(265))
       CALL HFILL(41012,R,0.,WT*SQME)
       R=-1000.

      DO I=1,240
        INDTMP=I-0.5
        IF(EDEP(I).GT.0.) THEN
         CALL HFILL(202,INDTMP,0.,EDEP(I))
         CALL HFILL(203,INDTMP,0.,TDEP(I))
        ENDIF
      ENDDO                                       

C--   Plastic Veto Hits
      DO I=1,20
        J=I+240
        IF(EDEP(J).GT.0.) THEN
         INDTMP=I-0.5
         CALL HFILL(204,INDTMP,0.,WT*SQME)
         CALL HFILL(205,INDTMP,0.,EDEP(J))
         CALL HFILL(206,INDTMP,0.,TDEP(J))
         ENDIF
      ENDDO

      ETARGET=0.
C--   Active Target Hits
      DO I=1,69
        J=I+260
        IF(EDEP(J).GT.0.) THEN
         IF(I.LE.6.and.I.LE.9)ETARGET=ETARGET+EDEP(J)
         INDTMP=I-0.5
         CALL HFILL(207,INDTMP,0.,WT*SQME)
         CALL HFILL(208,INDTMP,0.,EDEP(J))
         CALL HFILL(209,INDTMP,0.,TDEP(J))
         ENDIF
      ENDDO

C--   Trigger patterns
      IF (NR.EQ.11.AND.HTRIGGER(11).GT.0.) 
     +  CALL HFILL(210,10.5,0.,WT*SQME)
      IF (NR.EQ.7.AND.HTRIGGER(7).GT.0.) 
     +  CALL HFILL(210,10.5,0.,WT*SQME)
C--   Total weight for whole run
      CALL HFILL(211,WT*SQME,0.,WT*SQME)

C--   Pile-up in PHI-THETA plane
      DO I=1,240
        IF (EDEP(I).GT.0.) CALL HFILL(212,CSIPHI(I),CSITHT(I),WT*SQME)
      ENDDO

C--   Increase COUNTERS
      DO I=0,49
        IF (COUNTER(I).NE.0.) CALL HFILL(213,I+0.5,0.,WT*SQME)
      ENDDO

C--   First Particle Polar Angle
      IF(PART(1,1,NR)**2+PART(2,1,NR)**2+PART(3,1,NR)**2.GE.1.E-20)THEN
          THTT= PART(3,1,NR)/SQRT(PART(1,1,NR)**2+PART(2,1,NR)**2
     +                                           +PART(3,1,NR)**2)
      ELSE
          THTT= 0.
      ENDIF

      IF (ABS(THTT).LE.1) THEN
*yw4f ommit D and add anum
*        THTT=ACOSD(THTT)
        THTT=anum*ACOS(THTT)
*yw4f end
      ELSEIF(THTT.GT.1.)  THEN
        THTT=0.
      ELSE
        THTT=180.
      ENDIF

C--   Acceptance vs THTT,THT1
      IF (NR.EQ.7.AND.HTRIGGER(7).EQ.1)       THEN
*yw4f ommit D and add anum
*        CALL HFILL(214,COSD(THTT),0.,WT*SQME)         
*        CALL HFILL(215,COSD(THT1),0.,WT*SQME)
        CALL HFILL(214,COS(THTT/anum),0.,WT*SQME)         
        CALL HFILL(215,COS(THT1/anum),0.,WT*SQME)
*yw4f end         
        CALL HFILL(217,THTT-THT1, 0.,WT*SQME)
      ELSEIF (NR.EQ.11.AND.HTRIGGER(11).EQ.1) THEN
c        IF (NR.EQ.11.AND.ETARGET.GT.0.) GOTO 2234
*yw4f ommit D and add anum
*        CALL HFILL(214,COSD(THTT),0.,WT*SQME)         
*        CALL HFILL(215,COSD(THT1),0.,WT*SQME)
        CALL HFILL(214,COS(THTT/anum),0.,WT*SQME)         
        CALL HFILL(215,COS(THT1/anum),0.,WT*SQME)
*yw4f end         
        CALL HFILL(217,THTT-THT1, 0.,WT*SQME)
 2234   CONTINUE
      ENDIF

      IF (NR.EQ.7.OR.NR.EQ.11) THEN
c        IF (NR.EQ.11.AND.ETARGET.GT.0.) GOTO 5555
        CALL HFILL(216,THTT,0.,WT*SQME)
*yw4f ommit D and anum         
*        CALL HFILL(218,COSD(THTT),0.,WT*SQME)         
*        CALL HFILL(219,COSD(THT1),0.,WT*SQME)         
*        CALL HFILL(220,COSD(THTT),0.,1.)

        CALL HFILL(218,COS(THTT/anum),0.,WT*SQME)         
        CALL HFILL(219,COS(THT1/anum),0.,WT*SQME)         
        CALL HFILL(220,COS(THTT/anum),0.,1.)
*yw4f end         
 5555   CONTINUE
      ENDIF

C--   Multiple coincidences filling
      IF (ICOINCID.EQ.2) THEN
        IF (HTRIGGER(11).GT.0.) CALL HFILL(310,10.5,0.,WT*SQME)
        CALL HFILL(311,WT*SQME,0.,WT*SQME)
      ELSEIF (ICOINCID.EQ.3) THEN
        IF (HTRIGGER(11).GT.0.) CALL HFILL(410,10.5,0.,WT*SQME)
        CALL HFILL(411,WT*SQME,0.,WT*SQME)
      ELSEIF (ICOINCID.EQ.4) THEN
        IF (HTRIGGER(11).GT.0.) CALL HFILL(510,10.5,0.,WT*SQME)
        CALL HFILL(511,WT*SQME,0.,WT*SQME)
      ENDIF

      IF (RPHOT0.GT.25..AND.EDEPCAL.GT.55.) CALL HFILL(601,RPHOT0,0.,1.)
      IF (RPHOT2.GT.25..AND.EDEPCAL.GT.55.) CALL HFILL(602,RPHOT2,0.,1.)

C--   Hardware Triger
      IF(LTRIGGER(7).EQ.1) THEN

C--   Fill CsI reference histos
      ECSIMAX=0.
      IECSIMAX=0
      EDEPVT=0.
      DO I=1,240 ! 240 individual CsI modules
C--    Overflows
       IF(EDEP(I).GT.140.)EDEP(I)=139.99 
       IF(EDEP(I).GT.0.) THEN
         IF(I.LE.200)CALL HFILL(3241  ,EDEP(I),0.,WT*SQME)
         CALL HFILL(3242  ,EDEP(I),0.,WT*SQME)
         CALL HFILL(3000+I,EDEP(I),0.,WT*SQME)
       ENDIF
       IF(EDEP(I).GT.ECSIMAX) IECSIMAX=I
       ECSIMAX=MAX(EDEP(I),ECSIMAX)
       IF(I.GT.220) EDEPVT=EDEPVT+EDEP(I)
      ENDDO

       DO I=1,7
         IF(IECSIMAX.GE.1.OR.IECSIMAX.LE.240) THEN
           ECSIMAX=ECSIMAX+EDEP(NN200(I,IECSIMAX))
         ELSEIF(IECSIMAX.GE.201.OR.IECSIMAX.LE.240) THEN
           ECSIMAX=ECSIMAX+EDEP(NN40(I,IECSIMAX-200))
         ELSE
           CONTINUE
         ENDIF
       ENDDO

C       IF(ECSIMAX.LT.0.5) RETURN

       IF(IECSIMAX.GE.1.AND.IECSIMAX.LE.240) THEN
C--      Overflows
         IF(ECSIMAX.GT.140.)ECSIMAX=139.99 

C--   Calorimeter Hits (moved it after definition of NN energy sums
C     so we can use it in ADC threshold determination
         INDTMP=I-0.5
         IF(ECSIMAX.GT.36.0) CALL HFILL(201,INDTMP,0.,WT*SQME)

         CALL HFILL(1000+IECSIMAX,ECSIMAX,0.,WT*SQME)
         IF(IECSIMAX.LE.220)
     +     CALL HFILL(1241        ,ECSIMAX,0.,WT*SQME) 
           CALL HFILL(1242        ,ECSIMAX,0.,WT*SQME)
           IF(IECSIMAX.GT.0) 
     +     CALL HFILL(1243        ,IECSIMAX-0.5,0.,WT*SQME)         

         IF(EDEPVT.LT.5.) THEN
           CALL HFILL(1500+IECSIMAX,ECSIMAX,0.,WT*SQME)
           IF(IECSIMAX.LE.220)
     +       CALL HFILL(1741        ,ECSIMAX,0.,WT*SQME) 
             CALL HFILL(1742        ,ECSIMAX,0.,WT*SQME)
         ENDIF

         CALL HFILL(2000+IECSIMAX,EDEP(IECSIMAX),0.,WT*SQME)
         IF(IECSIMAX.LE.220)
     +   CALL HFILL(2241          ,EDEP(IECSIMAX),0.,WT*SQME)
         CALL HFILL(2242          ,EDEP(IECSIMAX),0.,WT*SQME)
       ENDIF

      ECLUMAX=0.
      IECLUMAX=0
      DO I=1,60 ! 60 individual clusters
C--     Overflows
        IF(CADC(I).GT.140.)CADC(I)=139.99
        IF(CTDC(I).GT.100.)CTDC(I)= 99.99
        IF(CADC(I).GT.ECLUMAX) IECLUMAX=I
        ECLUMAX=MAX(CADC(I),ECLUMAX)
      ENDDO

      IF(IECLUMAX.GE.1.AND.IECLUMAX.LE.60) THEN
        DO I=1,60
          IF(CADC(I).GT.0.) THEN
            CALL HFILL(4000+I,CADC(I),0.,WT*SQME)
            CALL HFILL(4061  ,CADC(I),0.,WT*SQME)
            IF(EDEPVT.LT.5.) THEN
              CALL HFILL(4500+I,CADC(I),0.,WT*SQME)
              CALL HFILL(4561  ,CADC(I),0.,WT*SQME)
            ENDIF
          ENDIF
        ENDDO
      ENDIF

      IF(IECLUMAX.GE.1.AND.IECLUMAX.LE.60) THEN
         CALL HFILL(5061         ,CADC(IECLUMAX),0.,WT*SQME)
         CALL HFILL(5000+IECLUMAX,CADC(IECLUMAX),0.,WT*SQME)
         CALL HFILL(6061         ,CTDC(IECLUMAX),0.,WT*SQME)
         CALL HFILL(6000+IECLUMAX,CTDC(IECLUMAX),0.,WT*SQME)
      ENDIF

      ENDIF
C--   End of Hardware Triger CsI Histograms

C--   Fill Shower Profile Histograms
      DO I=1,240
        IF(EDEP(I).GT.0..AND.HTRIGGER(7).EQ.1) THEN
C--     Angle between reconstructed shower direction THT1,PHI1
C--     and every CsI hit module CSITHT(I),CSIPHI(I) weighted
C--     with the energy deposited EDEP and WT*SQME factor

c--     Angle between the crystal considered and crystal with ECSIMAX
*yw4f ommit D and add anum
*        CSIOPEN=COSD(CSITHT(IECSIMAX))*COSD(CSITHT(I))+
*     +          SIND(CSITHT(IECSIMAX))*SIND(CSITHT(I))*
*     +          COSD(CSIPHI(IECSIMAX)-CSIPHI(I))

        CSIOPEN=COS(CSITHT(IECSIMAX)/anum)*COS(CSITHT(I)/anum)+
     +          SIN(CSITHT(IECSIMAX)/anum)*SIN(CSITHT(I)/anum)*
     +          COS((CSIPHI(IECSIMAX)-CSIPHI(I))/anum)
*yw4f end
        IF(ABS(CSIOPEN).LE.1.) THEN
*yw4f ommit D and add anum
          CSIOPEN=anum*ACOS(CSIOPEN)
*yw4f end
        ELSEIF (CSIOPEN.LT.-1.) THEN
          CSIOPEN=180.
        ELSEIF (CSIOPEN.GT. 1.) THEN
          CSIOPEN=0.
        ENDIF

c--     Angle between the crystal with ECSIMAX and the center of EDEP
*yw4f ommit D and add anum
*        CSIOFF=COSD(CSITHT(IECSIMAX))*COSD(THT1)+
*     +         SIND(CSITHT(IECSIMAX))*SIND(THT1)*
*     +         COSD(CSIPHI(IECSIMAX)-PHI1)

        CSIOFF=COS(CSITHT(IECSIMAX)/anum)*COS(THT1/anum)+
     +         SIN(CSITHT(IECSIMAX)/anum)*SIN(THT1/anum)*
     +         COS((CSIPHI(IECSIMAX)-PHI1)/anum)
*yw4f end
        IF(ABS(CSIOFF).LE.1.) THEN
*yw4f ommit D and add anum
*          CSIOFF=ACOSD(CSIOFF)
          CSIOFF=anum*ACOS(CSIOFF)
*yw4f end
        ELSEIF (CSIOFF.LT.-1.) THEN
          CSIOFF=180.
        ELSEIF (CSIOFF.GT. 1.) THEN
          CSIOFF=0.
        ENDIF

c--     Angle between the crystal considered and the center of EDEP
*yw4f ommit D and add anum
*        SHOWERPHI=COSD(THT1)*COSD(CSITHT(I))+
*     +            SIND(THT1)*SIND(CSITHT(I))*COSD(PHI1-CSIPHI(I))

        SHOWERPHI=COS(THT1/anum)*COS(CSITHT(I)/anum)+
     +            SIN(THT1/anum)*SIN(CSITHT(I)/anum)*
     +            COS((PHI1-CSIPHI(I))/anum)
*yw4f end
        IF(ABS(SHOWERPHI).LE.1.) THEN
*yw4f ommit D and add anum
*          SHOWERPHI=ACOSD(SHOWERPHI)
          SHOWERPHI=anum*ACOS(SHOWERPHI)
*yw4f end
        ELSEIF (SHOWERPHI.LT.-1.) THEN
          SHOWERPHI=179.999
        ELSEIF (SHOWERPHI.GT. 1.) THEN
          SHOWERPHI=0.001
        ENDIF

        IF(I.NE.IECSIMAX.AND.SHOWERPHI.NE.90.
     +      .OR.SHOWERPHI.NE.270.) THEN
         SHOWERRHO=26.!*TAND(SHOWERPHI)
        ELSE
         SHOWERRHO=3.3
        ENDIF

C        IF(ECSIMAX.LE.0.) RETURN

        CALL HFILL(721,SHOWERPHI,0.,EDEP(I)*WT*SQME)
        CALL HFILL(722,SHOWERPHI,0.,SHOWERRHO*WT*SQME)
*yw4f ommit D and add anum
*        CALL HFILL(725,COSD(SHOWERPHI),0.,EDEP(I)*WT*SQME)
        CALL HFILL(725,COS(SHOWERPHI/anum),0.,EDEP(I)*WT*SQME)
*yw4f end
        CALL HFILL(731,SHOWERPHI,0.,EDEP(I)*WT*SQME/ECSIMAX)
        CALL HFILL(732,SHOWERPHI,0.,SHOWERRHO*WT*SQME/ECSIMAX)
*yw4f ommit D and add anum
*        CALL HFILL(735,COSD(SHOWERPHI),0.,EDEP(I)*WT*SQME/ECSIMAX)
        CALL HFILL(735,COS(SHOWERPHI/anum),0.,EDEP(I)*WT*SQME/ECSIMAX)
*yw4f end

        IF(ECSIMAX.GT.0..AND.SHOWERPHI.LT.50.)
     +  CALL HFILL(741,EDEP(I)/ECSIMAX,SHOWERPHI,WT*SQME)

        IF(I.NE.IECSIMAX) THEN
          IF(SHOWERPHI.LT.CSIOPEN) THEN
            SHOWERPHI=SHOWERPHI-0.25*CSIOFF
          ELSE
            SHOWERPHI=SHOWERPHI+0.25*CSIOFF
          ENDIF
          IF(SHOWERPHI.LT.0.) SHOWERPHI=0.
          IF(SHOWERPHI.GT.0.) SHOWERPHI=180.
        ENDIF

        IF(I.NE.IECSIMAX.AND.SHOWERPHI.NE.90.
     +      .OR.SHOWERRHO.NE.270.) THEN
*yw4f ommit D and add anum
*         SHOWERRHO=26.*TAND(SHOWERPHI)
         SHOWERRHO=26.*TAN(SHOWERPHI/anum)
*yw4f end
        ELSE
         SHOWERRHO=3.3
        ENDIF

        CALL HFILL(723,SHOWERPHI,0.,EDEP(I)*WT*SQME)
        CALL HFILL(724,SHOWERPHI,0.,WT*SQME*SHOWERRHO)
*yw4f ommit D and add anum
*        CALL HFILL(726,COSD(SHOWERPHI),0.,EDEP(I)*WT*SQME)
        CALL HFILL(726,COS(SHOWERPHI/anum),0.,EDEP(I)*WT*SQME)
*yw4f end 
        CALL HFILL(733,SHOWERPHI,0.,EDEP(I)*WT*SQME/ECSIMAX)
        CALL HFILL(734,SHOWERPHI,0.,SHOWERRHO*WT*SQME/ECSIMAX)
*yw4f ommit D and add anum
*        CALL HFILL(736,COSD(SHOWERPHI),0.,EDEP(I)*WT*SQME/ECSIMAX)
        CALL HFILL(736,COS(SHOWERPHI/anum),0.,EDEP(I)*WT*SQME/ECSIMAX)
*yw4f end

        IF(ECSIMAX.GT.0..AND.SHOWERPHI.LT.50.)
     +  CALL HFILL(742,EDEP(I)/ECSIMAX,SHOWERPHI,WT*SQME)

        ENDIF ! EDEP(I)>0
      ENDDO
      
C-- radiative pion decay file pienug0 
      IF(HTRIGGER(11).eq.1.and.XNTP101(43).GT.0.2.and.
     .   XNTP101(291).LT.5..and.GA1D.GT.55.82.and.GA2D.GT.55.82.and.
     .   THT_B12.GT.25.)THEN
      CALL HFILL(960002,GA1D*(sin(tht_b12/114.6))**2/69.785
     .  -(GA1D/69.785+GA2D/69.785-1.)/(GA2D/69.785),0.,WT*SQME)
      write(29,5238) GA1D,GA2D,THT_B12,1000.*PART(4,1,NR),
     .               1000.*PART(4,2,NR),XNTP101(307),XNTP101(43),
     .               WT*SQME
      ENDIF

C-- radiative pion decay file pienug2
      IF(HTRIGGER(7).eq.1.and.XNTP101(43).GT.0.2.and.
     .   XNTP101(291).LT.5..and.((GA1D.GT.10.0.and.GA2D.GT.60.0)
     .   .or.(GA1D.GT.60.0.and.GA2D.GT.10.0)).and.
     .   THT_B12.GT.25.)THEN
      CALL HFILL(960003,GA1D*(sin(tht_b12/114.6))**2/69.785
     .  -(GA1D/69.785+GA2D/69.785-1.)/(GA2D/69.785),0.,WT*SQME)
      write(30,5238) GA1D,GA2D,THT_B12,1000.*PART(4,1,NR),
     .               1000.*PART(4,2,NR),XNTP101(307),XNTP101(43),
     .               WT*SQME
      ENDIF

 5238 FORMAT(6F12.3,F10.4,E14.5)

      DO I=241,242
         IF(EDEP(I).GT.0.2) THEN
          WRITE(77,*) I,CSIPHI(I_MAX1),CSIPHI(I_MAX2),
     .                  CSIPHI(I_MAX3)
         ENDIF
      ENDDO

      RETURN
      END   





