************************************************************************    
*
       SUBROUTINE NTP199
*
*      History
*      -------
*
*      19OCT95 SR created
*
*      Contents
*      --------
*      Book N-Tuple 199
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'
*yw4f reverse the orderof declaretiona and assignment
*      DATA TAG199/
*     +'TCALO1','TCALO2','W'/
*
*      CHARACTER*15 TAG199(3)

      CHARACTER*15 TAG199(3)
      DATA TAG199/
     +'TCALO1','TCALO2','W'/

*yw4f end
*
*-----------------------------------------------------------------------
*
      CALL HBOOKN(199,'TMP',3,'PIBETA',2000,TAG199)
*
      RETURN
      END   

************************************************************************    
*
       SUBROUTINE FILL199
*
*
*      History
*      -------
*
*      19OCT95 SR created
*
*      Contents
*      --------
*
*      Fill N-tuple 199 with temporary development variables
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'

      COMMON /FCLUSTER/CC(9,60),SCC(6,10),CADC(60),CTDC(60),
     +       FIREDL(60),FIREDH(60),BFIREDL(60),BFIREDH(60),
     +       NFIREDL,NFIREDH,SFIREDL(10),SFIREDH(10),
     +       BSFIREDL(10),BSFIREDH(10),NSFIREDL,
     +       NSFIREDH,CLTHT(60),CLPHI(60),THT12,HTRIGGER(50),
*yw4f change LTRIGGER TO LTRIGGER(50) conform to line123 of file ntp101.f
*     +       LTRIGGER,ICLUST,THT1,PHI1,TDC1,TDC2
     +       LTRIGGER(50),ICLUST,THT1,PHI1,TDC1,TDC2
*yw4f end

      REAL CADC,CTDC,THT1,PHI1,THT2,THT3,THT12,CLTHT,CLPHI,THTT,
     +     TDC1,TDC2
      INTEGER CC,SCC,FIREDL,FIREDH,BFIREDL,BFIREDH,NFIREDL,
     +        NFIREDH,SFIREDL,SFIREDH,BSFIREDL,BSFIREDH,NSFIREDL,
     +        NSFIREDH,HTRIGGER,LTRIGGER,ICLUST

      REAL XNTP199(3),TCALO1,TCALO2,ESUM,TCSI
      INTEGER ICSI,ITIME
*
*-----------------------------------------------------------------------
*

      CALL VZERO(XNTP199,3)

      TCALO1=1.E9 ! set TDC overflow
      DO ICSI=1,220 ! 220 individual CsI modules
       IF (ITDEP(ICSI).GT.0)                ! CsI timing
     +     TCALO1=MIN(TDEP(ICSI),TCALO1)
      ENDDO

*
*       Evaluate time histos for proper TDC values. Acummulate energies
*       from left to right. If the energy crosses the threshold, remember
*       the time.
*
      TCALO2 = 1E9      ! set TDC overflow

      DO ICSI=1,220     ! 220 CsI modules
        ESUM=0
        TCSI=1E9
        IF (EDEP(ICSI) .GT. 0.) THEN
          DO ITIME=1,500
            ESUM = ESUM+THISTO(ICSI,ITIME)
            IF (ESUM.GT.THRESHOLD(1)) THEN
              TCSI = (ITIME - 1)*0.01 + 0.005 ! 10ps binning
              GOTO 10
            ENDIF
          ENDDO
 10       IF (TCSI .LT. TCALO2) TCALO2 = TCSI
        ENDIF
      ENDDO

      XNTP199(1)=TCALO1
      XNTP199(2)=TCALO2
      XNTP199(3)=WT*SQME

      IF(HTRIGGER(7).EQ.1) CALL HFN(199,XNTP199)

      RETURN
      END   
