************************************************************************    
*
*       main.f
*
*       PIBETA Geant main program. Initialization of interactive/non-
*       interactive version according to INTx flags, which are set in
*       the makefile via -DINTx
*
*       INT0: Non-interactive version
*       INT1: PAW interactive version
*       INT2: PAW++ interactive version
*
*       History
*       -------
*       3AUG95 SR created
*
************************************************************************    
*
      PROGRAM PBGEANT
*   
      PARAMETER (NWGEAN=5000000,NWPAW=5000000)
      COMMON/GCBANK/GEANT(NWGEAN)    
      COMMON/PAWC/PAW(NWPAW)  
      COMMON/QUEST/IQUEST(100)
*
      COMMON/GPARAM/INTER,VERSION,IFRMT
*   
*     ------------------------------------------------------------------    
*
*       Set version. This line is updated after every change of the code
*
      VERSION=0.9
*
*       Determine mode. Default mode is non-interactive
*
      INTER=0
*  
#ifdef INT1
      INTER=1
      CALL GPAW(NWGEAN,NWPAW)
#endif
*
#ifdef INT2
      INTER=2
      CALL GPAWPP(NWGEAN,NWPAW)
#endif
*
      IF(INTER.EQ.0) THEN
        CALL GZEBRA(NWGEAN)    
        CALL HLIMIT(-NWGEAN)   
*   
*             Geant initialization. 
        CALL UGINIT   
*   
*             Start events processing.  
        CALL GRUN 
*   
*             End of run.   
        CALL UGLAST   
      ENDIF

      END   
