/**********************/
/*   Ignore this file */
/**********************/

#include "xwin.h"




void SetRect(Rect *rec,int left,int top,int right,int bottom)
{
	rec->left=left;
	rec->right=right;
	rec->top=top;
	rec->bottom=bottom;
}

void InsetRect(Rect *rec,int x,int y)
{
	rec->left+=x;rec->right-=x;
	rec->top+=y;rec->bottom-=y;
}

void OffsetRect(Rect *rec,int x,int y)
{
	rec->left+=x;rec->right+=x;
	rec->top+=y;rec->bottom+=y;
}

void MoveTo(int x,int y)
{
	thePort->penX=x;
	thePort->penY=y;
}

void LineTo(int x,int y)
{
	XDrawLine(dpy,thePort->window,thePort->gc,
		thePort->penX,thePort->penY,x,y);

	thePort->penX=x;
	thePort->penY=y;
}

void DrawLines(int num,Point *pnts,int mode)
{
/*	if(mode==0)mode=CoordModePrevious;
*/	XDrawLines(dpy,thePort->window,thePort->gc,(XPoint *)pnts,num,mode);
}

void FrameRect(Rect *rec)
{
	XDrawRectangle(dpy,thePort->window,thePort->gc,
		rec->left,rec->top,
		rec->right-rec->left,rec->bottom-rec->top);
}

void FillRect(Rect *rec)
{
	XFillRectangle(dpy,thePort->window,thePort->gc,
		rec->left,rec->top,
		rec->right-rec->left,rec->bottom-rec->top);
}

void FillOval(Rect *rec)
{
	XFillArc(dpy,thePort->window,thePort->gc,
		rec->left,rec->top,
		rec->right-rec->left,rec->bottom-rec->top,
		0,360);
}

void EraseRect(Rect *rec)
{
	XClearArea(dpy,thePort->window,
		rec->left,rec->top,
		rec->right-rec->left,rec->bottom-rec->top,
		false);
}

void EraseWindow(WindowPtr wind)
{
	XClearWindow(dpy,wind->window);
}


