/***********************/
/*    Ignore this file */
/***********************/

#if defined(MacOS)
#undef MacOS
#endif


#if defined(VAX)
#include <decw$include/Xlib.h>
#include <decw$include/Xutil.h>
#endif

#if defined(unix)
#include <X11/Xlib.h>
#endif

#define FontName\
         "-Adobe-New Century Schoolbook-Medium-R-Normal--*-140-*-*-P-*-ISO8859-1"
#define blackColor 0
#define whiteColor 1
#define cyanColor 2
#define magentaColor 3
#define redColor 4
#define blueColor 5
#define greenColor 6
#define yellowColor 7

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif

#ifndef false
#define false 0
#define true 1
#endif

#ifndef Boolean
#define Boolean char
#endif



typedef struct 
{
	int left;
	int top;
	int right;
	int bottom;
}Rect;

typedef struct
{
	short h,v;
}Point;

typedef struct
{
	Window window;
	GC gc;
	int penX;
	int penY;
	Rect portRect;
}WindowRec;
typedef WindowRec *WindowPtr;


extern Display *dpy;
extern Screen *screen;
extern WindowPtr thePort;


/**** xwin.c *****/
WindowPtr NewWindow(Rect *bounds,char* windName);
void DisposeWindow(WindowPtr wind);
void SetPort(WindowPtr newPort);
void ForeColor(int color);
void BackColor(int color);
int doDefineColor(int n);
void ShowCursor(void);
void HideCursor(void);

/**** quickdraw.c*****/
void SetRect(Rect *rec,int left,int top,int right,int bottom);
void InsetRect(Rect *rec,int x,int y);
void OffsetRect(Rect *rec,int x,int y);
void MoveTo(int x,int y);
void LineTo(int x,int y);
void DrawLines(int num,Point *pnts,int mode);
void FrameRect(Rect *rec);
void FillRect(Rect *rec);
void FillOval(Rect *rec);
void EraseRect(Rect *rec);
void EraseWindow(WindowPtr wind);

/***** a few misc things ******/
#define ExitToShell() exit(0)
#define NewPtr(A) malloc(A)
#define DisposPtr(A) free(A)
typedef char** Handle;
typedef char* Ptr;
#define OSErr int
#define nil NULL

/* some temporary compatibility definitions*/
#define CGrafPtr long
#define CtoPstr(A)
#define Alert(A,B) printf("Error. Exiting...\n")
#define TextSize(A)
#define DrawString(A) printf(A)
#define PaintRect(A)



