************************************************************************    
*
       SUBROUTINE TDC1
*
*      History
*      -------
*
*      101095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'
      REAL TTMP
*
C--   Sensitive detector + energy deposition
      IF (ISVOL.NE.0.AND.EDEP(IDTYPE).GT.0.) THEN

Ctemporary code-EF--------------------------------------------------------
c       IF (IDTYPE.GE.1.AND.IDTYPE.LE.240.AND.ITDEP(IDTYPE).EQ.0
c     +                .AND.EDEPTOT.EQ.0.) THEN
c       CSITHT(IDTYPE)=CSITHT(IDTYPE) + ACOSD( VECT(3)/
c     +               SQRT(VECT(1)**2+VECT(2)**2+VECT(3)**2) )
c       CSIPHI(IDTYPE)=CSIPHI(IDTYPE) + ATAN2D(VECT(2),VECT(1))
c       CSIANG(IDTYPE)=CSIANG(IDTYPE) + 1.
c
c       ENDIF
C-----------------------------------------------------------------------

C--    22 cm long CsI Modules, Distance to PMT -> RPMT comes from adc.f
       IF (IDTYPE.GE.1.AND.IDTYPE.LE.240.AND.EDEP(IDTYPE).GT.
     +   THRESHOLD(1)) THEN
         RPMT(IDTYPE)=
     +   SQRT(CSIVECT(1)**2+CSIVECT(2)**2+(CSIVECT(3)-22.)**2)
C--      TDEP in nanoseconds
         TTMP=1.E9*TOFG+RPMT(IDTYPE)/(29.9792/1.8)
         IF (ITDEP(IDTYPE).EQ.1) THEN
           TDEP(IDTYPE)=MIN(TDEP(IDTYPE),TTMP)
         ELSE
           TDEP(IDTYPE)=TTMP
         ENDIF
C--    Stop TDC:
       ITDEP(IDTYPE)=1
       ENDIF

C--    Plastic veto staves, Distance to PMT -> RPMT comes from adc.f
       IF (IDTYPE.GE.241.AND.IDTYPE.LE.260) THEN
         RPMT(IDTYPE)=
     +   SQRT(CSIVECT(1)**2+CSIVECT(2)**2+(CSIVECT(3)-30.)**2)
C--      TDEP in nanoseconds
         TTMP=1.E9*TOFG!+RPMT(IDTYPE)/(29.9792/1.8)
         IF (ITDEP(IDTYPE).EQ.1) THEN
           TDEP(IDTYPE)=MIN(TDEP(IDTYPE),TTMP)
         ELSE
           TDEP(IDTYPE)=TTMP
         ENDIF
C--    Stop TDC:
       ITDEP(IDTYPE)=1
       ENDIF

C--    Cosmic veto, Distance to PMT -> RPMT comes from adc.f
       IF (IDTYPE.GE.331.AND.IDTYPE.LE.335) THEN
*         RPMT(IDTYPE)=
*     +   SQRT(CSIVECT(1)**2+CSIVECT(2)**2+(CSIVECT(3)-30.)**2)
C--      TDEP in nanoseconds
         TTMP=1.E9*TOFG
         IF (ITDEP(IDTYPE).EQ.1) THEN
           TDEP(IDTYPE)=MIN(TDEP(IDTYPE),TTMP)
         ELSE
           TDEP(IDTYPE)=TTMP
         ENDIF
C--    Stop TDC:
       ITDEP(IDTYPE)=1
       ENDIF

C--    Target, Distance to PMT -> RPMT comes from adc.f
       IF (IDTYPE.GE.261.AND.IDTYPE.LE.329) THEN
*         RPMT(IDTYPE)=
*     +   SQRT(CSIVECT(1)**2+CSIVECT(2)**2+(CSIVECT(3)-30.)**2)
C--      TDEP in nanoseconds
         TTMP=1.E9*TOFG
         IF (ITDEP(IDTYPE).EQ.1) THEN
           TDEP(IDTYPE)=MIN(TDEP(IDTYPE),TTMP)
         ELSE
           TDEP(IDTYPE)=TTMP
         ENDIF
C--    Stop TDC:
       ITDEP(IDTYPE)=1
       ENDIF

      ENDIF
*
      RETURN
      END   
