      SUBROUTINE ABORT_NONHADR

*     25OCT95 EF
*
C--   Aborts event tracking if PI+ decays and does not interact 
*     hadronically

      IMPLICIT NONE
      INTEGER I
*      
*     ----------------------------------------------------------------- 

      INCLUDE '../common.inc'

*     ----------------------------------------------------------------- 
*      
C--   Flag for hadronic event, elastic (in)coherent or hadronic inelastic
*     (coherent/incoherent) pion interaction, see GHEISHA manual, p. 48

      DO I=1,NMEC    ! incident pion interacts hadronically
         IF (ISTAK.EQ.0.AND.IPART.EQ.8.AND.
     +       LMEC(I).EQ.12.OR.LMEC(I).EQ.13.AND.
     +       LMEC(I).EQ.19.OR.LMEC(I).EQ.20) THEN
           HADFLAG=1
         ENDIF       ! if incident pion decays, set abort event flag
         IF (ISTAK.EQ.0.AND.IPART.EQ.8.AND.LMEC(I).EQ.5) THEN
           IEOTRI=1
         ENDIF
      ENDDO

      IF (HADFLAG.EQ.1) THEN
        IF (IPART.EQ.1)  GAMFLAG=1 
        IF (IPART.EQ.7)  PI0FLAG=1 
        IF (IPART.EQ.13) NEUFLAG=1
      ENDIF

      RETURN
      END   
