*
C--   Define geometry of Kugelgehoize
*
      IF (IPLANAR.EQ.11) RETURN ! Calibration with CsI + NaI, CsI Off 1 m

      DATA PKUGE /69.,70.5,0.,180.,0.,360./
      DATA PKUGO /0.,6.,1.5/

      CALL GSVOLU ('KUGE','SPHE',12,PKUGE,6,ISTATUS)  ! Iron
      CALL GSVOLU ('KUGO','TUBE', 1,PKUGO,3,ISTATUS)  ! Air
*
C--     Position KUGELGEHOEZE
*
      IF (KUGEL.EQ.1)
     +  CALL GSPOS ('KUGE',1,'MAMA',0.0,0.0,0.0,0,'ONLY')

C--   Define cement floor

      DATA PFLOOR /200.,30.,200./

      CALL GSVOLU ('FLOO','BOX ',14,PFLOOR,3,ISTATUS)  ! Shielding cement

      IF (KUGEL.EQ.1)
     +  CALL GSPOS ('FLOO',1,'MAMA',0.0,-158.0,0.0,0,'ONLY')
