************************************************************************    
*
       SUBROUTINE NTP100
*
*      Write User DATA cards into Ntple 100
*
*      History
*      -------
*      101095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'
      COMMON/HADR_PAR/IGHEISHA
      INTEGER I,IGHEISHA
*
      DATA TAG100/'W COSMIC','W GAMMA',   'W POSITRON','W PISTOP',    
     +          'W PIMUNU',  'W PIGMUNU', 'W PIENU',   'W PIEGNU',  
     +          'W PI3ENU',  'W PIE3NU',  'W PIBETA',  'W PI2EMUNU',
     +          'W MICHEL',  'W MUGE2NUE','W MU2NU3E', 'W MU3E',    
     +          'W MUGE',    'W MUE2G',   'W MUEGG',   'W NG',      
     +          'W NGG',     'W PIZN',    'W PZP',     'W PPN',     
     +          'W ZZN',     'W MZP',     'W MPN',     
     +          'P COSMIC',  'P GAMMA',   'P POSITRON','P PISTOP',    
     +          'P PIMUNU',  'P PIGMUNU', 'P PIENU',   'P PIEGNU',  
     +          'P PI3ENU',  'P PIE3NU',  'P PIBETA',  'P PI2EMUNU',
     +          'P MICHEL',  'P MUGE2NUE','P MU2NU3E', 'P MU3E',    
     +          'P MUGE',    'P MUE2G',   'P MUEGG',   'P NG',      
     +          'P NGG',     'P PIZN',    'P PZP',     'P PPN',     
     +          'P ZZN',     'P MZP',     'P MPN',     
     +          'TGAMMA', 'DTGAMMA','TPOSITR','DTPOSITR',
     +          'TINC',   'DTINC',  'DZCOSMIC', 'DXCOSMIC',
     +          'RLENGTH','RLUXARY','RSTART','HISTO','PINC','DPINC',
     +          'DX0','DY0','DZ0','DPX0','DPY0','DPZ0',
     +          'ZBEAM','DBX','DBY','CMUON','CPOSITRON','FBEAM',
     +          'CTEMP1','CTEMP2',
     +          'TRIG','HADR','COMP','PAIR','BREM','ANNI','DCAY',
     +          'DRAY','LOSS','PHOT','CUTGAM','MULS',
     +          'NONH','PHNU','GHEI','IPMT','KUGE','RCAL','AUNI',
     +          'TUNI','NPHO','WADC','EMTH','EMW1','EMW2','IADC',
     +          'ICOI','THR1','THR2','THR3','YEAR'/
*yw4f move data block from ntp101.f here
      DATA TAG101/
     +'IR','TB','IP1','IP2','IP3','X0','Y0','Z0','PX1','PY1','PZ1',     1-11
     +'T1','PX2','PY2','PZ2','T2','PX3','PY3','PZ3','T3','ETAR','EDGD', 12-22  
     +'PV01','PV02','PV03','PV04','PV05','PV06','PV07','PV08','PV09',   23-31
     +'PV10','PV11','PV12','PV13','PV14','PV15','PV16','PV17','PV18',   32-40
     +'PV19','PV20','DEPV','MWX1','MWX2','MWY1','MWY2','MWZ1','MWZ2',   41-49
*     +'P01','P02','P03','P04','P05','P06','P07','P08','P09','P10',     50-59
     +'EC1','EC2','EC3','T12','T13','T23','S12','S13','S23','PSQ',      50-59
*    +'A01','A02','A03','A04','A05','A06','A07','A08','A09','A10',      60-69
     +'PC1','PC2','PC3','LAM','IB','SDP','SDM','TE1','TE2','A10',       60-69
     +'A11','A12','A13','A14','A15','A16','A17','A18','A19','A20',      70-79
     +'A21','A22','A23','A24','A25','A26','A27','A28','A29','A30',      80-89
     +'A31','A32','A33','A34','A35','A36','A37','A38','A39','A40',      90-99
     +'A41','A42','A43','A44','A45','A46','A47','A48','A49','A50',      100-109
     +'B01','B02','B03','B04','B05','B06','B07','B08','B09','B10',      110-119
     +'B11','B12','B13','B14','B15','B16','B17','B18','B19','B20',      120-129
     +'B21','B22','B23','B24','B25','B26','B27','B28','B29','B30',      130-139
     +'B31','B32','B33','B34','B35','B36','B37','B38','B39','B40',      140-149
     +'B41','B42','B43','B44','B45','B46','B47','B48','B49','B50',      150-159
     +'C01','C02','C03','C04','C05','C06','C07','C08','C09','C10',      160-169
     +'C11','C12','C13','C14','C15','C16','C17','C18','C19','C20',      170-179
     +'C21','C22','C23','C24','C25','C26','C27','C28','C29','C30',      180-189
     +'C31','C32','C33','C34','C35','C36','C37','C38','C39','C40',      190-199
     +'C41','C42','C43','C44','C45','C46','C47','C48','C49','C50',      200-209
     +'D01','D02','D03','D04','D05','D06','D07','D08','D09','D10',      210-219
     +'D11','D12','D13','D14','D15','D16','D17','D18','D19','D20',      220-229
     +'D21','D22','D23','D24','D25','D26','D27','D28','D29','D30',      230-239
     +'D31','D32','D33','D34','D35','D36','D37','D38','D39','D40',      240-249
     +'H01','H02','H03','H04','H05','H06','H07','H08','H09','H10',      250-259
     +'H11','H12','H13','H14','H15','H16','H17','H18','H19','H20',      260-269
     +'V01','V02','V03','V04','V05','V06','V07','V08','V09','V10',      270-279
     +'V11','V12','V13','V14','V15','V16','V17','V18','V19','V20',      280-289
     +'ECAL','ECAV','CVFR','CVBA','CVTO','CVSL','CVSR','ECVE',          290-297
     +'TTAR','TDGD','TMPV','TMMW','TCALO','TCALOVET','TCOSMV',          298-304
     +'WT','SQME','RA','NCL','NSCL','NCLH','NSCH','THT12','HT7',        305-313
     +'HT8','HT11','WC','NH1','NH2','DH1','DH2','TR','PI0','NEU',       314-323
     +'GAM','DEG1','DEG2','REG1','REG2','SQM1','SQM2','SQM3','THTC',    324-332
     +'LT7','LT8','LT11','TDC1','TDC2','SEED1','SEED2','CMAX','ENAI',   333-341
     +'ENAV','TNAI','TNAV','NPV'/                                       342-345


*yw4f end
*      
C--   Row-wise Ntple Definition
      CALL HBOOKN(100,'USER CARDS',L100,'PIBETA',2000,TAG100)

      XNTP100(1)=WCOSMIC(1)
      XNTP100(2)=WGAMMA(1)
      XNTP100(3)=WPOSITRON(1)
      XNTP100(4)=WPISTOP(1)
      XNTP100(5)=WPI_MUNU(1)
      XNTP100(6)=WPI_MUNUG(1)
      XNTP100(7)=WPI_ENU(1)
      XNTP100(8)=WPI_ENUG(1)
      XNTP100(9)=WPI_3ENU(1)
      XNTP100(10)=WPI_E3NU(1)
      XNTP100(11)=WPIBETA(1)
      XNTP100(12)=WPI_MU2ENU(1)
      XNTP100(13)=WMICHEL(1)
      XNTP100(14)=WMU_E2NUG(1)
      XNTP100(15)=WMU_3E2NU(1)
      XNTP100(16)=WMU_3E(1)
      XNTP100(17)=WMU_GE(1)
      XNTP100(18)=WMU_E2G(1)
      XNTP100(19)=WMUE_GG(1)
      XNTP100(20)=WPIMP_NG(1)
      XNTP100(21)=WPIMP_NGG(1)
      XNTP100(22)=WPIMP_PI0N(1)
      XNTP100(23)=WPIPP_PIPPI0P(1)
      XNTP100(24)=WPIPP_PIPPIPN(1)
      XNTP100(25)=WPIMP_PI0PI0N(1)
      XNTP100(26)=WPIMP_PIMPI0P(1)
      XNTP100(27)=WPIMP_PIMPIPN(1)

C--   Store branching ratio in RBRANCH array      
      DO I=1,27
        RBRANCH(I)=XNTP100(I)
      ENDDO

      XNTP100(28)=WCOSMIC(2)
      XNTP100(29)=WGAMMA(2)
      XNTP100(30)=WPOSITRON(2)
      XNTP100(31)=WPISTOP(2)
      XNTP100(32)=WPI_MUNU(2)
      XNTP100(33)=WPI_MUNUG(2)
      XNTP100(34)=WPI_ENU(2)
      XNTP100(35)=WPI_ENUG(2)
      XNTP100(36)=WPI_3ENU(2)
      XNTP100(37)=WPI_E3NU(2)
      XNTP100(38)=WPIBETA(2)
      XNTP100(39)=WPI_MU2ENU(2)
      XNTP100(40)=WMICHEL(2)
      XNTP100(41)=WMU_E2NUG(2)
      XNTP100(42)=WMU_3E2NU(2)
      XNTP100(43)=WMU_3E(2)
      XNTP100(44)=WMU_GE(2)
      XNTP100(45)=WMU_E2G(2)
      XNTP100(46)=WMUE_GG(2)
      XNTP100(47)=WPIMP_NG(2)
      XNTP100(48)=WPIMP_NGG(2)
      XNTP100(49)=WPIMP_PI0N(2)
      XNTP100(50)=WPIPP_PIPPI0P(2)
      XNTP100(51)=WPIPP_PIPPIPN(2)
      XNTP100(52)=WPIMP_PI0PI0N(2)
      XNTP100(53)=WPIMP_PIMPI0P(2)
      XNTP100(54)=WPIMP_PIMPIPN(2)

      XNTP100(55)=EGAMMA(1)
      XNTP100(56)=EGAMMA(2)
      XNTP100(57)=EPOSITRON(1)
      XNTP100(58)=EPOSITRON(2)
      XNTP100(59)=TINC(1)
      XNTP100(60)=TINC(2)
      XNTP100(61)=ZXCOSMIC(1)
      XNTP100(62)=ZXCOSMIC(2)
      XNTP100(63)=ILEN
      XNTP100(64)=ILUX
      XNTP100(65)=ISTART
      XNTP100(66)=IHISTO
      XNTP100(67)=BEAM(1)
      XNTP100(68)=BEAM(2)
      XNTP100(69)=BEAM(3)
      XNTP100(70)=BEAM(4)
      XNTP100(71)=BEAM(5)
      XNTP100(72)=BEAM(6)
      XNTP100(73)=BEAM(7)
      XNTP100(74)=BEAM(8)
      XNTP100(75)=ZBEAM
      XNTP100(76)=DIVBEAM(1)
      XNTP100(77)=DIVBEAM(2)
      XNTP100(78)=CONBEAM(1)
      XNTP100(79)=CONBEAM(2)
      XNTP100(80)=FBEAM
      XNTP100(81)=CTEMP(1)
      XNTP100(82)=CTEMP(2)

      XNTP100(83)=NEVENT
      XNTP100(84)=IHADR
      XNTP100(85)=ICOMP
      XNTP100(86)=IPAIR
      XNTP100(87)=IBREM
      XNTP100(88)=IANNI
      XNTP100(89)=IDCAY
      XNTP100(90)=IDRAY
      XNTP100(91)=ILOSS
      XNTP100(92)=IPHOT
      XNTP100(93)=PCUTGA
      XNTP100(94)=IMULS

      XNTP100(95)=IGHAD
      XNTP100(96)=IPHOTONUCLEAR
      XNTP100(97)=IGHEISHA
      XNTP100(98)=IPMT
      XNTP100(99)=KUGEL
      XNTP100(100)=RCALO
      XNTP100(101)=UNIFORMITY(1)
      XNTP100(102)=UNIFORMITY(2)
      XNTP100(103)=PHOTOELECTRON(1)
      XNTP100(104)=WADC
      XNTP100(105)=METHOD
      XNTP100(106)=EMWPC(1)
      XNTP100(107)=EMWPC(2)
      XNTP100(108)=IADCTDC
      XNTP100(109)=ICOINCID      
      XNTP100(110)=THRESHOLD(1)
      XNTP100(111)=THRESHOLD(2)
      XNTP100(112)=THRESHOLD(3)
      XNTP100(113)=IYEAR

C--   Fill Row-wise Ntp
      CALL HFN(100,XNTP100)      

      RETURN
      END   

