************************************************************************    
*
*       output.f
*
*       Write event information after each finished event
*
*       History
*       -------
*       16DEC91 KAA created
*       11OCT95 EF  updated
*
************************************************************************    
*
      SUBROUTINE UHINIT  
*   
************************************************************************    
*
*       Book user histograms
*
************************************************************************    
*   
      INCLUDE 'common.inc'
      COMMON/QUEST/IQUEST(100)
      INTEGER IQUEST,ISTAT
*
*-----------------------------------------------------------------------
*   
*     Book histograms, manually (not digitized by routine HITS)
*      
C--   Overide default maximum number of records (4000) 
C--   to 65000 records maximum allowed, 4096 words each

      IQUEST(10) = 65000
*
      IF (IFILE.GT.0) THEN
        CALL HROPEN(2,'PIBETA','geant.rz','NQ',4096,ISTAT)
        CALL HBSET ('BSIZE',4096,ISTAT)

*     NTP Reserved IDs: 100-199
*     Histogram Reserved IDs: 200-999

*     Book Ntples & HISTOGRAMS

      CALL NTP100

*     NTP 101 is written in RW format
        IF (IFORMAT.EQ.1) CALL NTP101

      ENDIF

      END   
*
*=======================================================================
*
************************************************************************    
*
*       Fill histograms
*
************************************************************************    
*
      SUBROUTINE GUOUT  
*   
      IMPLICIT NONE
      INCLUDE 'common.inc'

*-----------------------------------------------------------------------
*
      INTEGER NTBEAM,NTTARG,NUBUF
      REAL UBUF(10),TOFCR,ETYPE,EWEIGHT,MELEM_SQ
      REAL HITS(2,50)
      INTEGER I,NUMVS(1),ITRACK(1,50),INUMBV(1,50),NHITS
      DATA NUMVS/0/
*
*-----------------------------------------------------------------------
*
      IF (IFORMAT.EQ.1) CALL FILL101

 9999 CONTINUE

      END
*
*=======================================================================
*
*
      SUBROUTINE UGLAST 
      IMPLICIT NONE
      include 'common.inc'
      INTEGER ICYCLE
*   
*     102195 EF Added call to random coincidence generator
*   
************************************************************************    
*
*       Termination routine to print histograms and statistics
*
************************************************************************    
*   
*   
      CALL GLAST    

      IF (IFILE.GT.0) THEN
        CALL HROUT(0,ICYCLE,' ')
        CALL HREND('PIBETA')
      ENDIF

      CLOSE(2)
      CALL IGEND    
*   
      END   
*
*=======================================================================
*

      INCLUDE 'ntp100.f'
      INCLUDE 'ntp101.f'

