	program rms

	parameter (nbin=63)
	parameter (nsim=100000)
	implicit double precision (a-h,o-z)
	external fcn
	common/data/
     +      ydat(nbin),en(nsim),th(nsim),ysim(nbin),
     +      en_p(nsim),th_p(nsim),
     +      ip,sumdat,sumsim
	integer*4 sumdat,sumsim

	open (unit=22, file='e_th.dat', status='old')
	open (unit=23, file='e_th.sim', status='old')

	sumdat=0.
	do i=15,nbin
	  read (22,*) ydat(i)
	  sumdat=sumdat+ydat(i)
	enddo
	
	sumsim=0.
	ip=1
 111	read (23,*,end=999) en(ip),th(ip)
	if(en(ip).lt.10..or.en(ip).gt.190.
     +     .or.th(ip).gt.70.) goto 111
	ip=ip+1
	sumsim=sumsim+1.
	goto 111

 999	continue

	do i=1,nbin
	  ysim(i)=ysim(i)*sumdat/sumsim
	enddo

	open (unit=5, file='rms.dat', status='old')
	open (unit=6, file='rms.out', status='new')
	call minuit(fcn,0)
	
	write(6,765) ysim
 765	format(f10.2)

	stop
	end

	subroutine fcn(npar,gin,f,x,iflag)

	parameter(nbin=63)  
	parameter (nsim=100000)

	implicit double precision (a-h,o-z)
	dimension x(4), gin(4),c(4)

	common/data/
     +      ydat(nbin),en(nsim),th(nsim),ysim(nbin),
     +      en_p(nsim),th_p(nsim),
     +      ip,sumdat,sumsim
	integer*4 sumdat,sumsim

	f=0.

	do i=1,ip
	  en_p(i)=en(i)+c(1)+c(2)*en(i)
	  th_p(i)=en(i)+c(3)+c(4)*th(i)
	enddo

        sumsim=0.
        do i=1,ip

	  if     (abs(en_p(i)-20.).le.10.) then
            l=0
	  elseif (abs(en_p(i)-40.).le.10.) then
            l=1
	  elseif (abs(en_p(i)-60.).le.10.) then
            l=2
	  elseif (abs(en_p(i)-80.).le.10.) then
            l=3
	  elseif (abs(en_p(i)-100.).le.10.) then
            l=4
	  elseif (abs(en_p(i)-120.).le.10.) then
            l=5
	  elseif (abs(en_p(i)-140.).le.10.) then
            l=6
	  elseif (abs(en_p(i)-160.).le.10.) then
            l=7
	  elseif (abs(en_p(i)-180.).le.10.) then
            l=8
	  else
	    l=-1
	  endif

	  if     (abs(th_p(i)-5.).le.5.) then
            k=1
	  elseif (abs(th_p(i)-15.).le.5.) then
            k=2	  
	  elseif (abs(th_p(i)-25.).le.5.) then
            k=3  
	  elseif (abs(th_p(i)-35.).le.5.) then
            k=4	  
	  elseif (abs(th_p(i)-45.).le.5.) then
            k=5	  
	  elseif (abs(th_p(i)-55.).le.5.) then
            k=6	  
	  elseif (abs(th_p(i)-65.).le.5.) then
            k=7	  
	  else
	    k=-1
	  endif

	  j=7*l+k

          if(j.ge.1.and.j.le.63) ysim(j)=ysim(j)+1
	enddo

        do i=15,nbin
          f=f+(ydat(i)-ysim(i)*sumdat/sumsim)**2
        enddo

	return
	end
