************************************************************************    
*
       SUBROUTINE TDC2
*
*      History
*      -------
*      101095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE 'common.inc'

      REAL TPMT

C--   Do only if we are in sensitive detector and energy is deposited
      IF (ISVOL.EQ.0.OR.DESTEP.EQ.0.) RETURN

C--   New method: store energy deposition in TOF array
      IF (IDTYPE.GE.1.AND.IDTYPE.LE.240) THEN

C--   Calculate time when light reaches PM [in ns]

      TPMT = 1.E9*TOFG

      ENDIF
*
      RETURN
      END   
